
// xixunDemoDlg.h : header file
//

#pragma once
#include "afxwin.h"
#include "afxcmn.h"
#include "afxpropertygridctrl.h"
#include "XiXunLedProgram.h"

// CxixunDemoDlg dialog
class CxixunDemoDlg : public CDialogEx
{
// Construction
public:
	CxixunDemoDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_XIXUNDEMO_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnFileSavefile();
	afx_msg void OnFileQuit();
	afx_msg void OnFileLoadfile();
	CComboBox m_ComboBox;
	afx_msg void OnBnClickedButtonNewProgram();
	CTreeCtrl m_tree;
	CButton m_buttonNewProgram;
	//afx_msg void OnSelchangeCombo();
	CStatic m_staticPos;
	afx_msg void OnClickTree1(NMHDR *pNMHDR, LRESULT *pResult);
	CMFCPropertyGridCtrl m_ppGrid;
	afx_msg void OnBnClickedButtonNewPage();
	void myExpandTree(HTREEITEM hTreeItem);
	afx_msg void OnBnClickedButtonNewGlopage();
	/*void InitProgramPropertyGrid(BOOL bl);
	void InitPagePropertyGrid(CString strName, BOOL bl);
	void InitFilewinPropertyGrid(CString strName, BOOL bl);
	void InitTablewinPropertyGrid(CString strName, BOOL bl);
	void InitSinglineTextPropertyGrid(CString strName, BOOL bl);
	void InitMultilineTextPropertyGrid(CString strName, BOOL bl);
	void InitPeroidPropertyGrid(CString strName, BOOL bl);
	void InitDigitalClockPropertyGrid(CString strName, BOOL bl);
	void InitAnalogClockPropertyGrid(CString strName, BOOL bl);
	void InitTempHumiPropertyGrid(CString strName, BOOL bl);
	void InitTextFilePropertyGrid(CString strName, BOOL bl);
	void InitPicturePropertyGrid(CString strName, BOOL bl);
	void InitVideoPropertyGrid(CString strName, BOOL bl);
	void InitGIFPropertyGrid(CString strName, BOOL bl);
	void InitRTFPropertyGrid(CString strName, BOOL bl);
	void InitFlashPropertyGrid(CString strName, BOOL bl);
	void InitTablePropertyGrid(CString strName, BOOL bl);
	void InitConstraintPropertyGrid(CString strName, BOOL bl);*/

	void UpdateConstraintPropertyGrid(wchar_t* wsItemName, struct DateConstraint* pdc,
		struct TimeConstraint* ptc, struct WeekConstraint* pwc);
	void UpdateProgramProperty(struct ProgramAttribute* pAttr);
	void UpdatePagePropertyGrid(struct PageAttribute* pAttr);
	void UpdateFilewinPropertyGrid(struct FileWindowAttribute* pAttr);
	void UpdateTablewinPropertyGrid(struct TableWindowAttribute* pAttr);
	void UpdateSinglineTextPropertyGrid(struct TextWindowAttribute* pAttr, 
		struct SingLineTextAttribute* pSt, struct TextAttribute* pText);
	void UpdateMultilineTextPropertyGrid(struct TextWindowAttribute* pAttr,
		struct MultiLineTextAttribute* pMt, struct TextAttribute* pText);
	void UpdatePeroidPropertyGrid(struct PeroidWindowAttribute* pAttr, struct DATE_TIME* pDt);
	void UpdateDigitalClockPropertyGrid(struct DigitalClockWindowAttribute* pAttr);
	void UpdateAnalogClockPropertyGrid(struct AnalogClockWindowAttribute* pAttr);
	void UpdateTempHumiPropertyGrid(struct TemperatureHumidityWindowAttribute* pAttr);
	void UpdateTextFilePropertyGrid(struct TextFileAttribute* pAttr);
	void UpdatePicturePropertyGrid(struct PictureAttribute* pAttr);
	void UpdateVideoPropertyGrid(struct VideoAttribute* pAttr);
	void UpdateGIFPropertyGrid(struct GIFAttribute* pAttr);
	void UpdateRTFPropertyGrid(struct RTFAttribute* pAttr);
	void UpdateFlashPropertyGrid(struct FlashAttribute* pAttr);
	void UpdateTablePropertyGrid(struct TableAttribute* pAttr);
	void ErrorMessage();
	CString IntToString(int intValue);
	void splitString(int nCount, const wchar_t* wsString, wchar_t** wsSplit);
	void DestoryCurToolbar(int nToolbar);
	void SetProgramToolbar();
	void SetWindowToolbar();
	void SetItemToolbar();
	void SetTableToolbar();
	void SetTextToolbar();
	void DisableToolbar(int nToolbar);
	void ToolbarAddItem(int nItem);
	int GetFontSize(LPLOGFONT pLogFont);
	int GetLogFontHeight(int nFontSize);
private:
	std::map<int, int> item_map;
	std::map<CString, int> name_map;
	std::map<CString, CString> who_map;
	CString m_sItemName;
	int m_itemType;
	int nMagic;
public:
	CButton m_NewPageButton;
	afx_msg void OnBnClickedButtonRemove();
	afx_msg void OnClose();
	CButton m_newGlobalPageButton;
	afx_msg void OnFileCompile();
	afx_msg void OnSetfocusCombo();
	CToolBar* m_tb, *m_tb_window, *m_tb_item, *m_tb_table, *m_tb_text;
	BOOL bGlobalPageExist;
	BOOL bProgramExist;
	int nCurToolbar;
	afx_msg void OnIdtbNewprogram();
	afx_msg void OnIdtbNewpage();
	afx_msg void OnIdtbNewglobalpage();
	afx_msg void OnIdtbNewFilewindow();
	afx_msg void OnIdtbNewFlash();
	afx_msg void OnIdtbNewGif();
	afx_msg void OnIdtbNewMulti();
	afx_msg void OnIdtbNewPicture();
	afx_msg void OnIdtbNewRtf();
	afx_msg void OnIdtbNewSingle();
	afx_msg void OnIdtbNewTable();
	afx_msg void OnIdtbNewTablewindow();
	afx_msg void OnIdtbNewTemphumi();
	afx_msg void OnIdtbNewTextfile();
	afx_msg void OnIdtbNewTimerwindow();
	afx_msg void OnIdtbNewVideo();
	afx_msg void OnIdtbNewanalogclock();
	afx_msg void OnIdtbNewdigitalclock();
protected:
	afx_msg LRESULT OnAfxWmPropertyChanged(WPARAM wParam, LPARAM lParam);
public:
	afx_msg void OnEditRemove();
	afx_msg void OnAboutClickme();
	afx_msg void OnBnClickedButton1();
	afx_msg void OnBnClickedButton2();
	afx_msg void OnBnClickedButton3();
};
