// ConvertTxtOnTimerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ConvertTxtOnTimer.h"
#include "ConvertTxtOnTimerDlg.h"
#include "EncodeMaterial.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConvertTxtOnTimerDlg dialog
CString GetAppPath()
{
	CString m_sCPath,str ;
	char dir[300] ;
	HINSTANCE hpin= AfxGetInstanceHandle() ;
	GetModuleFileName(hpin,dir,299);
	m_sCPath = dir ;//ǰ·
	str =  AfxGetApp()->m_pszExeName;
	str = str+".exe" ;
	m_sCPath.MakeLower() ;
	str.MakeLower() ;
	int ipos ;
	ipos  =  m_sCPath.Find(str ) ;
	m_sCPath.Delete(ipos ,str.GetLength()) ;  
	if ( m_sCPath.Right(1)!='\\')
	{
		m_sCPath =  m_sCPath+"\\" ;
	}
	return m_sCPath ;
}
CConvertTxtOnTimerDlg::CConvertTxtOnTimerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConvertTxtOnTimerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConvertTxtOnTimerDlg)
	m_strTxtPathName = _T("");
	m_strXrsPathName = _T("");
	m_uiTimerInterval = 15;
	m_uiWidth = 320;
	m_uiHeight = 240;
	m_strFont = _T("Arial");
	m_uiFontSize = 16;
	m_uiLineSpacing = 0;
	m_bTimeFlag=TRUE;
	m_uiSuccessedCount=0;
	m_uiFailedCount=0;
	m_strXmlProjectFilePath = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_strWritingFlagFilePathName="";
	m_WriteFlag=0;
	
}

void CConvertTxtOnTimerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConvertTxtOnTimerDlg)
	DDX_Control(pDX, IDC_CHECK3, m_ctrlFontU);
	DDX_Control(pDX, IDC_CHECK2, m_ctrlFontI);
	DDX_Control(pDX, IDC_CHECK1, m_ctrlFontB);
	DDX_Control(pDX, IDC_BUTTON6, m_ctrlBkColor);
	DDX_Control(pDX, IDC_BUTTON5, m_ctrlFontColor);
	DDX_Text(pDX, IDC_EDIT1, m_strTxtPathName);
	DDX_Text(pDX, IDC_EDIT2, m_strXrsPathName);
	DDX_Text(pDX, IDC_EDIT3, m_uiTimerInterval);
	DDV_MinMaxUInt(pDX, m_uiTimerInterval, 1, 360000);
	DDX_Text(pDX, IDC_EDIT4, m_uiWidth);
	DDX_Text(pDX, IDC_EDIT5, m_uiHeight);
	DDX_Text(pDX, IDC_EDIT6, m_strFont);
	DDX_Text(pDX, IDC_EDIT7, m_uiFontSize);
	DDV_MinMaxUInt(pDX, m_uiFontSize, 7, 128);
	DDX_Text(pDX, IDC_EDIT8, m_uiLineSpacing);
	DDV_MinMaxUInt(pDX, m_uiLineSpacing, 0, 16);
	DDX_Text(pDX, IDC_EDIT9, m_strXmlProjectFilePath);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CConvertTxtOnTimerDlg, CDialog)
	//{{AFX_MSG_MAP(CConvertTxtOnTimerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_WM_TIMER()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_MESSAGE(1000,OnMainDlgrMsgPro)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConvertTxtOnTimerDlg message handlers
LRESULT CConvertTxtOnTimerDlg::OnMainDlgrMsgPro(WPARAM wParam, LPARAM lParam)
{
	m_uiSuccessedCount+=(int)wParam;
	m_uiFailedCount+=(int)lParam;
	CString strSuccessedCount="";
	strSuccessedCount.Format("%d",m_uiSuccessedCount);
	CString strFailedCount="";
	strFailedCount.Format("%d",m_uiFailedCount);
	GetDlgItem(IDC_STATIC_COUNT)->SetWindowText("Successed:"+strSuccessedCount+",Failed:"+strFailedCount);
	return 0;
}
#include "Tlhelp32.h"
void KillConvertProcess()
{
		HANDLE hndl = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS,0);
		DWORD dwsma = GetLastError();

		DWORD dwExitCode = 0;

		PROCESSENTRY32  procEntry={0};
		procEntry.dwSize = sizeof( PROCESSENTRY32 );
		Process32First(hndl,&procEntry);
		do
		{
			if(!strcmp(procEntry.szExeFile,_T("ConvertTxtOnTimer.exe")))
			{
				break;
			}
			//cout<<"Running Process "<<"          "<<procEntry.szExeFile<<endl;
		}while(Process32Next(hndl,&procEntry));
		
	///////////////////////////////////////////////////////////////	
		HANDLE hHandle;
		hHandle=::OpenProcess(SYNCHRONIZE|PROCESS_TERMINATE,FALSE,procEntry.th32ProcessID);
		
		//hHandle = ::OpenProcess(PROCESS_ALL_ACCESS,0,procEntry.th32ProcessID);
		
		::GetExitCodeProcess(hHandle,&dwExitCode);
		::TerminateProcess(hHandle,dwExitCode);
}
LONG WINAPI TopLevelUnhandledExceptionFilter(PEXCEPTION_POINTERS pExceptionInfo)
{
//	SYSTEMTIME time;
//	memset(&time, 0x0, sizeof(SYSTEMTIME));
//	GetLocalTime(&time);
//	CString csFileName = _T("");
//	csFileName.Format(_T("c:\\lds_dump_%4d%02d%02d_%02d%02d%02d.dmp"), 
//		time.wYear, time.wMonth, time.wDay, time.wHour, time.wMinute, time.wSecond);
//	HANDLE hDumpFile = CreateFile(csFileName, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);  
//	if(hDumpFile == INVALID_HANDLE_VALUE) return EXCEPTION_EXECUTE_HANDLER;
//    
//    MINIDUMP_EXCEPTION_INFORMATION dumpInfo;
//    dumpInfo.ExceptionPointers = pExceptionInfo;
//    dumpInfo.ThreadId = GetCurrentThreadId();  
//    dumpInfo.ClientPointers = TRUE;
//
//    MiniDumpWriteDump(GetCurrentProcess(), GetCurrentProcessId(), hDumpFile, MiniDumpNormal, &dumpInfo, NULL, NULL);  
//    CloseHandle(hDumpFile);
 	//?????,????
	CString strPath=GetAppPath()+"ConvertTxtOnTimer.exe";
//	char path[512];
//	memset(path, 0x0, 512*sizeof(TCHAR));
//	GetModuleFileName(global_wnd.hInst, path, 512);
	PROCESS_INFORMATION pi;
	STARTUPINFO si;
    memset(&si,0,sizeof(si));
    si.cb=sizeof(si);
    si.wShowWindow=SW_SHOW;
    si.dwFlags=STARTF_USESHOWWINDOW;
 	CreateProcess(strPath, NULL, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);
 	//AfxMessageBox(strPath);
    SetErrorMode( SEM_NOGPFAULTERRORBOX );
	KillConvertProcess();
	return EXCEPTION_EXECUTE_HANDLER;
}
BOOL GetFileExist(LPCTSTR strName)
{
	DWORD dwAttr = GetFileAttributes(strName);
	if(dwAttr == 0xFFFFFFFF)   //ļв
	{
		return FALSE;
	}
	else
		return TRUE;
	
}		
BOOL CConvertTxtOnTimerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.
	SetUnhandledExceptionFilter(TopLevelUnhandledExceptionFilter);

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	StartupEncodeMaterial();
	GetParamFromParamIni();	
	SetAutoRun();
	if(GetFileExist(m_strTxtPathName)==TRUE)
	{
		OnButton3();
	}
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CConvertTxtOnTimerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CConvertTxtOnTimerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CConvertTxtOnTimerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CConvertTxtOnTimerDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CFileDialog dlg(TRUE, NULL, 
		NULL, OFN_HIDEREADONLY, "\r\nTXT FILE(*.txt) |*.txt|",
		this);
	dlg.m_ofn.Flags |= OFN_NOCHANGEDIR;	
	if (IDOK == dlg.DoModal())
	{
		m_strTxtPathName=dlg.GetPathName();
		UpdateData(FALSE);
	}	
}

void CConvertTxtOnTimerDlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CFileDialog dlg(TRUE, NULL, 
		NULL, OFN_HIDEREADONLY, "\r\nMATERIAL FILE(*.xrs) |*.xrs|",
		this);
	dlg.m_ofn.Flags |= OFN_NOCHANGEDIR;	
	if (IDOK == dlg.DoModal())
	{
		m_strXrsPathName=dlg.GetPathName();
		UpdateData(FALSE);
	}	
}
BOOL   FolderExist(CString strPath)
{
	WIN32_FIND_DATA   wfd;
	BOOL rValue = FALSE;
	HANDLE hFind = FindFirstFile(strPath, &wfd);
    if ((hFind != INVALID_HANDLE_VALUE) && (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
    {
		rValue = TRUE;   
	}
	FindClose(hFind);
    return rValue;
}

BOOL SetStrKeyString(CString strKey,CString strValue)
{
	HKEY hKey = NULL; 
	//BYTE i; 
	CString str=_T("Software\\Microsoft\\Windows\\CurrentVersion\\Run"); 
	if (::RegOpenKey(HKEY_LOCAL_MACHINE, str, &hKey) != ERROR_SUCCESS) return false; 
	
	LPBYTE owner_Get=new BYTE[500]; 
	memset(owner_Get,0x00,500*sizeof(BYTE));
	strcpy((char *)owner_Get,strValue);
	if(::RegSetValueEx(hKey, (LPCTSTR)strKey, 0, REG_SZ, (CONST BYTE *)owner_Get, (strValue.GetLength()+1)*sizeof(TCHAR))!= ERROR_SUCCESS)
		return FALSE;
	RegCloseKey(hKey);
	return TRUE;
}
BOOL CConvertTxtOnTimerDlg::SetAutoRun()
{
	CString strPath=GetAppPath()+"ConvertTxtOnTimer.exe";
	SetStrKeyString(_T("ConverTxtOnTimer"),strPath);

	return TRUE;
}
CString GetFileNameFromFilePathName(CString strPathName)
{
	while(1)
	{
		int iCount=strPathName.Find("\\");
		if(iCount==-1)
		{
			return strPathName;
		}
		strPathName=strPathName.Right(strPathName.GetLength()-iCount-1);
	}
	return "";
}

void CConvertTxtOnTimerDlg::OnButton3() 
{
	// TODO: Add your control notification handler code here
	
	UpdateData(TRUE);
	if(GetFileExist(m_strTxtPathName)==FALSE)
	{
		AfxMessageBox("Txt file \""+m_strTxtPathName+"\" is not exist");
		return;
	}
	if(m_strXrsPathName.GetLength()>4)
	{
		if(m_strXrsPathName.Right(3)!="xrs")
		{
			AfxMessageBox(m_strXrsPathName+" is not right xrs format");
			return;
		}
	}
	else
	{
		if(m_strXrsPathName=="")
		AfxMessageBox(m_strXrsPathName+" can not be empty!");
		return;
		
	}
	if(FolderExist(m_strContabFilePath))
	{
	}
	else
	{
		if(m_strContabFilePath=="")
			AfxMessageBox(m_strContabFilePath+" can not be empty!!");
		else
			AfxMessageBox(m_strContabFilePath+" Folder is not exist!!!");
		return;
	}
	//GetFileExist(m_strXrsPathName)
	if(m_bTimeFlag)
	{
		SaveParamToParamIni();	
		CString strOnlyFileName=GetFileNameFromFilePathName(m_strXmlProjectFilePath);
		m_strWritingFlagFilePathName=m_strXmlProjectFilePath.Left(m_strXmlProjectFilePath.GetLength()-strOnlyFileName.GetLength())+"writing.txt";
		if(GetFileExist(m_strWritingFlagFilePathName)==TRUE)
			DeleteFile(m_strWritingFlagFilePathName);
		m_WriteFlag=0;
		ConVertTxtToXrs();
		SetTimer(1,m_uiTimerInterval*1000*60,NULL);
		//SetTimer(1,m_uiTimerInterval*100,NULL);
		GetDlgItem(IDC_BUTTON3)->SetWindowText("Stop Timer");
		GetDlgItem(IDC_EDIT1)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT2)->EnableWindow(FALSE);
	}
	else
	{
		KillTimer(1);
		GetDlgItem(IDC_BUTTON3)->SetWindowText("Start Timer");
		GetDlgItem(IDC_EDIT1)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT2)->EnableWindow(TRUE);
		
	}

	m_bTimeFlag=!m_bTimeFlag;
}

void CConvertTxtOnTimerDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	switch(nIDEvent)
	{
	case 1:
		ConVertTxtToXrs();
		break;
	case 2:
		KillTimer(2);
		ConVertTxtToXrs();
		break;
	}
	CDialog::OnTimer(nIDEvent);
}

void GetDirFromProPathName(CString strPathName,CString &strDir)
{
	strDir="";
	if (strPathName.Find(".")<0)
	{
		CString strtemp="";
		while(1)
		{
			int iCount=strPathName.Find("\\");
			if (iCount==-1)
			{
				break;
			}
			strDir+=strPathName.Left(iCount+1);
			strPathName=strPathName.Right(strPathName.GetLength()-iCount-1);
		}
		if (strDir.GetLength()>1)
		{
			strDir=strDir.Left(strDir.GetLength()-1);
		}
	}
	else
	{
		CString strtemp="";
		while(1)
		{
			int iCount=strPathName.Find(".");
			if (iCount==-1)
			{
				break;
			}
			strDir+=strPathName.Left(iCount+1);
			strPathName=strPathName.Right(strPathName.GetLength()-iCount-1);
			//	return ;
		}
		if (strDir.GetLength()>1)
		{
			strDir=strDir.Left(strDir.GetLength()-1);
		}
	}
	return ;
}

UINT _Thread_CreateXmlContabFile(LPVOID lparam)
{
	CConvertTxtOnTimerDlg *dlg=(CConvertTxtOnTimerDlg *)lparam;
	if(dlg->m_WriteFlag==1)
		return 0;
	char cContabFilePathName[500]={0};
	strcpy(cContabFilePathName,dlg->m_strContabFilePath);
	int iResult1=DLL_CreatXmlContabFile(cContabFilePathName);
	if(iResult1<0)
	{
		//SetTimer(3,1000,NULL);
		//AfxMessageBox("dd");
		//AfxMessageBox("Create Xml Contab file failed");
		Sleep(1000);
		dlg->m_WriteFlag=0;
		::AfxBeginThread(_Thread_CreateXmlContabFile,dlg,THREAD_PRIORITY_TIME_CRITICAL,0,0,NULL);
		return 0;
	}
	dlg->m_WriteFlag=0;
//	if(GetFileExist(dlg->m_strWritingFlagFilePathName)==TRUE)
//		DeleteFile(dlg->m_strWritingFlagFilePathName);//ɾд
	return 0;
}
UINT _Thread_ConVertTxtToXrs(LPVOID lparam)
{
	CConvertTxtOnTimerDlg *dlg=(CConvertTxtOnTimerDlg *)lparam;
	if(dlg->m_WriteFlag==1)
		return 0;
//	if(GetFileExist(dlg->m_strWritingFlagFilePathName)==TRUE)
//		return 0;		
	int iSuccessResult=0;
	int iFailedResult=0;
	char cContabFilePathName[500]={0};
	strcpy(cContabFilePathName,dlg->m_strContabFilePath);
//	HANDLE	m_hFile=NULL;
//	m_hFile=CreateFile((LPCTSTR)(dlg->m_strWritingFlagFilePathName),//ļָ
//			GENERIC_READ|GENERIC_WRITE,// ģʽ
//			FILE_SHARE_READ|FILE_SHARE_WRITE|FILE_SHARE_DELETE,
//			NULL, //ȫ
//			CREATE_ALWAYS, // ʽ
//			0, // ļ
//			NULL // ָԵļָ
//			); 
//	CloseHandle(m_hFile);
//	Sleep(2000);
	dlg->m_WriteFlag=1;
	
	char cTxtFilePathName[500]={0};
	strcpy(cTxtFilePathName,dlg->m_strTxtPathName);
	char cTxtXrsFilePathName[500]={0};
	strcpy(cTxtXrsFilePathName,dlg->m_strXrsPathName);
	char cFontName[20]={0};
	strcpy(cFontName,dlg->m_strFont);
	bool bFontB=FALSE;
	bool bFontI=FALSE;	
	bool bFontU=FALSE;
	if(dlg->m_ctrlFontB.GetCheck())
		bFontB=TRUE;
	if(dlg->m_ctrlFontI.GetCheck())
		bFontI=TRUE;
	if(dlg->m_ctrlFontU.GetCheck())
		bFontU=TRUE;

	//CString strCommandLine="\""+GetAppPath()+"MfcEncodeMaterialCMD.exe\" -t \""+dlg->m_strTxtPathName+"\" \""+dlg->m_strXrsPathName+"\""
	//		+" 32 32 NULL 12345 Arial 255 16 false false true 1 true 2";
	//	AfxMessageBox(strCommandLine);
	//	WinExec(strCommandLine,SW_HIDE);	
	int iResult=ComplierTxtFile(cTxtFilePathName,cTxtXrsFilePathName,dlg->m_uiWidth,dlg->m_uiHeight,NULL,dlg->m_ctrlBkColor.GetColor()
		,cFontName,dlg->m_ctrlFontColor.GetColor(),dlg->m_uiFontSize,bFontB,bFontI,bFontU
			,dlg->m_uiLineSpacing,true,0);
	if(iResult==0)
	{
		//AfxMessageBox("ComplierTxtFile success",MB_ICONINFORMATION|MB_OK);
		iSuccessResult=1;
		//m_uiSuccessedCount++;
	}
	else
	{
		//GetDlgItem(IDC_STATIC_COUNT)->SetWindowText(strCount);
		//AfxMessageBox("ComplierTxtFile failed",MB_ICONINFORMATION|MB_OK);
		iFailedResult=1;
		Sleep(1000);
		dlg->m_WriteFlag=0;
		::AfxBeginThread(_Thread_ConVertTxtToXrs,dlg,THREAD_PRIORITY_TIME_CRITICAL,0,0,NULL);
		return 0;
		//SetTimer(2,1000,NULL);
		//m_uiFailedCount++;
	}
	::PostMessage(dlg->m_hWnd,1000,iSuccessResult,iFailedResult);
	int iResult1=DLL_CreatXmlContabFile(cContabFilePathName);
	if(iResult1<0)
	{
		//SetTimer(3,1000,NULL);
		//AfxMessageBox("dd");
		//AfxMessageBox("Create Xml Contab file failed");
		Sleep(1000);
		dlg->m_WriteFlag=0;
		::AfxBeginThread(_Thread_CreateXmlContabFile,dlg,THREAD_PRIORITY_TIME_CRITICAL,0,0,NULL);
		return 0;
	}
	dlg->m_WriteFlag=0;
//	if(GetFileExist(dlg->m_strWritingFlagFilePathName)==TRUE)
//		DeleteFile(dlg->m_strWritingFlagFilePathName);//ɾд
	return 0;
}
void CConvertTxtOnTimerDlg::ConVertTxtToXrs() 
{
	UpdateData(TRUE);
	::AfxBeginThread(_Thread_ConVertTxtToXrs,this,THREAD_PRIORITY_TIME_CRITICAL,0,0,NULL);
}

void CConvertTxtOnTimerDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	//ShutDownEncodeMaterial();
	SaveParamToParamIni();	
	CDialog::OnClose();
}

void CConvertTxtOnTimerDlg::OnButton5() 
{
	// TODO: Add your control notification handler code here
//	m_ctrlFontColor.SetColor()
	m_ctrlFontColor.GetColor();
}

void CConvertTxtOnTimerDlg::OnButton6() 
{
	// TODO: Add your control notification handler code here
	m_ctrlBkColor.GetColor();
		
}

void CConvertTxtOnTimerDlg::OnButton4() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CFileDialog dlg(TRUE, NULL, 
		NULL, OFN_HIDEREADONLY, "\r\nMATERIAL FILE(*.xml *.lxd) |*.xml;*.lxd|",
		this);
	dlg.m_ofn.Flags |= OFN_NOCHANGEDIR;	
	if (IDOK == dlg.DoModal())
	{
		m_strXmlProjectFilePath=dlg.GetPathName();
		UpdateData(FALSE);
		m_strContabFilePath=m_strXmlProjectFilePath.Left(m_strXmlProjectFilePath.GetLength()-4);
	}	
}

void CConvertTxtOnTimerDlg::OnOK() 
{
	// TODO: Add extra validation here
	SaveParamToParamIni();
	return;
	CDialog::OnOK();
}
void CConvertTxtOnTimerDlg::SaveParamToParamIni()
{

	UpdateData(TRUE);
	CString FILENAME="";
	FILENAME=GetAppPath()+"param.ini";

	
	WritePrivateProfileString("Param","Font",m_strFont,FILENAME);
	CString strFontSize="";
	strFontSize.Format("%d",m_uiFontSize);
	WritePrivateProfileString("Param","FontSize",strFontSize,FILENAME);
	//
	CString strFontB="";
	if(m_ctrlFontB.GetCheck())
		strFontB="true";
	else
		strFontB="false";
	WritePrivateProfileString("Param","FontB",strFontB,FILENAME);
	//б
	CString strFontI="";
	if(m_ctrlFontI.GetCheck())
		strFontI="true";
	else
		strFontI="false";
	WritePrivateProfileString("Param","FontI",strFontI,FILENAME);
	//»
	CString strFontU="";
	if(m_ctrlFontU.GetCheck())
		strFontU="true";
	else
		strFontU="false";
	WritePrivateProfileString("Param","FontU",strFontU,FILENAME);
	//м
	CString strLineSpacing="";
	strLineSpacing.Format("%d",m_uiLineSpacing);
	WritePrivateProfileString("Param","Linespacing",strLineSpacing,FILENAME);
	//ɫ
	CString strFontColor="";
	strFontColor.Format("%ud",m_ctrlFontColor.GetColor());
	WritePrivateProfileString("Param","FontColor",strFontColor,FILENAME);
	
	//ɫ
	CString strBkColor="";
	strBkColor.Format("%ud",m_ctrlBkColor.GetColor());
	WritePrivateProfileString("Param","BkColor",strBkColor,FILENAME);
	

	WritePrivateProfileString("Param","TxtPathName",m_strTxtPathName,FILENAME);
	WritePrivateProfileString("Param","XrsPathName",m_strXrsPathName,FILENAME);
	WritePrivateProfileString("Param","ProjectPathName",m_strXmlProjectFilePath,FILENAME);
	
	CString strHeight="";
	strHeight.Format("%d",m_uiHeight);
	WritePrivateProfileString("Param","ProgramHeight",strHeight,FILENAME);
	CString strWidth="";
	strWidth.Format("%d",m_uiWidth);
	WritePrivateProfileString("Param","ProgramWidth",strWidth,FILENAME);
	CString strTimerInterval="";
	strTimerInterval.Format("%d",m_uiTimerInterval);
	WritePrivateProfileString("Param","TimerInterval",strTimerInterval,FILENAME);
	

}
void CConvertTxtOnTimerDlg::GetParamFromParamIni()
{
	CString FILENAME="";
	FILENAME=GetAppPath()+"param.ini";
	if(GetFileExist(FILENAME))
	{
		int dwSize=1000;
		m_uiHeight=GetPrivateProfileInt("Param","ProgramHeight",64,FILENAME);
		m_uiWidth=GetPrivateProfileInt("Param","ProgramWidth",32,FILENAME);
		

		CString strtemp=_T("");
		GetPrivateProfileString("Param","Font","Arial",strtemp.GetBuffer(dwSize),dwSize,FILENAME);
		strtemp.ReleaseBuffer();
		m_strFont=strtemp;
		
		m_uiFontSize=GetPrivateProfileInt("Param","FontSize",32,FILENAME);
		//
		strtemp=_T("");
		GetPrivateProfileString("Param","FontB","false",strtemp.GetBuffer(dwSize),dwSize,FILENAME);
		strtemp.ReleaseBuffer();
		if(strtemp=="true")
			m_ctrlFontB.SetCheck(1);
		else
			m_ctrlFontB.SetCheck(0);
		//б
		strtemp=_T("");
		GetPrivateProfileString("Param","FontI","false",strtemp.GetBuffer(dwSize),dwSize,FILENAME);
		strtemp.ReleaseBuffer();
		if(strtemp=="true")
			m_ctrlFontI.SetCheck(1);
		else
			m_ctrlFontI.SetCheck(0);
		//»
		strtemp=_T("");
		GetPrivateProfileString("Param","FontU","false",strtemp.GetBuffer(dwSize),dwSize,FILENAME);
		strtemp.ReleaseBuffer();
		if(strtemp=="true")
			m_ctrlFontU.SetCheck(1);
		else
			m_ctrlFontU.SetCheck(0);
		//м
		m_uiLineSpacing=GetPrivateProfileInt("Param","Linespacing",0,FILENAME);
		//ɫ
		UINT uiTempColor=GetPrivateProfileInt("Param","FontColor",255,FILENAME);
		m_ctrlFontColor.SetColor((COLORREF)uiTempColor);
		//ɫ
		UINT uiTempBkColor=GetPrivateProfileInt("Param","BkColor",0,FILENAME);
		m_ctrlBkColor.SetColor((COLORREF)uiTempBkColor);
		
		
		strtemp=_T("");
		GetPrivateProfileString("Param","TxtPathName","",strtemp.GetBuffer(dwSize),dwSize,FILENAME);
		strtemp.ReleaseBuffer();
		m_strTxtPathName=strtemp;

		strtemp=_T("");
		GetPrivateProfileString("Param","XrsPathName","",strtemp.GetBuffer(dwSize),dwSize,FILENAME);
		strtemp.ReleaseBuffer();
		m_strXrsPathName=strtemp;
		strtemp=_T("");
		GetPrivateProfileString("Param","ProjectPathName","",strtemp.GetBuffer(dwSize),dwSize,FILENAME);
		strtemp.ReleaseBuffer();
		m_strXmlProjectFilePath=strtemp;
		m_strContabFilePath=m_strXmlProjectFilePath.Left(m_strXmlProjectFilePath.GetLength()-4);
		
		m_uiTimerInterval=GetPrivateProfileInt("Param","TimerInterval",0,FILENAME);
		UpdateData(FALSE);
	}
	else
	{
		m_ctrlFontColor.SetColor(RGB(255,0,0));
		m_ctrlBkColor.SetColor(RGB(0,0,0));
		
	}
	
	
}





















