// SendProgramByLedDataServerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SendProgramByLedDataServer.h"
#include "SendProgramByLedDataServerDlg.h"
#include "InterFaceDll.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
int WINAPI ProcessCallBackMessage (int Param1,char * Param2);
HWND m_DlgWnd=NULL;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSendProgramByLedDataServerDlg dialog

CSendProgramByLedDataServerDlg::CSendProgramByLedDataServerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSendProgramByLedDataServerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSendProgramByLedDataServerDlg)
	m_strLedDataServerAddress = _T("www.ledm2m.net");
	m_strProgramName = _T("4294912292");
	m_uiPort = 40000;
	m_strUserName = _T("alahover");
	m_strPassword = _T("888");
	m_strControllerID = _T("");
	m_strWebServerUrl = _T("");
	m_uiHeight = 32;
	m_uiProgramSize = 2835;
	m_uiWidth = 64;
	m_uiPageId=0;
	m_strProjectPathName = _T("");
	m_uiBrightNess = 0;
	m_iRadioPower = 0;
	m_uiPageIndex = 0;
	m_uiMainVersion = 9;
	m_strFtpDownloadTip = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	iCurGprsImeiCardNumber=0;
	m_iAuthResult=0;
	m_hEnableSendNextCmd=NULL;
}

void CSendProgramByLedDataServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSendProgramByLedDataServerDlg)
	DDX_Control(pDX, IDC_CHECK1, m_ctrlAutoPuttingListener);
	DDX_Control(pDX, IDC_PROGRESS1, m_ctrlProgress);
	DDX_Control(pDX, IDC_CHECK_WEB_COMMAND, m_ctrlCheckWeb);
	DDX_Control(pDX, IDC_LIST1, m_ctrlLinkedCardInfo);
	DDX_Text(pDX, IDC_EDIT_SERVER_ADDRESS, m_strLedDataServerAddress);
	DDX_Text(pDX, IDC_EDIT_PROGRAM_NAME, m_strProgramName);
	DDX_Text(pDX, IDC_EDIT_PORT, m_uiPort);
	DDX_Text(pDX, IDC_EDIT_USER_NAME, m_strUserName);
	DDX_Text(pDX, IDC_EDIT_PASSWORD, m_strPassword);
	DDV_MaxChars(pDX, m_strPassword, 8);
	DDX_Text(pDX, IDC_EDIT_CONTROLLER_ID, m_strControllerID);
	DDV_MaxChars(pDX, m_strControllerID, 15);
	DDX_Text(pDX, IDC_EDIT_WEB_SERVER_ADD, m_strWebServerUrl);
	DDX_Text(pDX, IDC_EDIT_PROGRAM_HEIGHT, m_uiHeight);
	DDX_Text(pDX, IDC_EDIT_PROGRAMSIZE, m_uiProgramSize);
	DDX_Text(pDX, IDC_EDIT_PROGRAM_WIDTH, m_uiWidth);
	DDX_Text(pDX, IDC_EDIT_PAGE_ID, m_uiPageId);
	DDX_Text(pDX, IDC_EDIT_PROJECT_PATH, m_strProjectPathName);
	DDX_Text(pDX, IDC_EDIT_BRIGHTNESS, m_uiBrightNess);
	DDV_MinMaxUInt(pDX, m_uiBrightNess, 0, 7);
	DDX_Radio(pDX, IDC_RADIO1, m_iRadioPower);
	DDX_Text(pDX, IDC_EDIT_ANYCAST_NUM, m_uiPageIndex);
	DDX_Text(pDX, IDC_EDIT_VERSION, m_uiMainVersion);
	DDX_Text(pDX, IDC_EDIT_FTP_DOWNLOAD_TIP, m_strFtpDownloadTip);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSendProgramByLedDataServerDlg, CDialog)
	//{{AFX_MSG_MAP(CSendProgramByLedDataServerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_LOGIN, OnButtonLogin)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON_DOWNLOAD, OnButtonDownload)
	ON_BN_CLICKED(IDC_BUTTON_GET_USER_CONTROLLER_INFO, OnButtonGetUserControllerInfo)
	ON_NOTIFY(NM_CLICK, IDC_LIST1, OnClickList1)
	ON_BN_CLICKED(IDC_CHECK_WEB_COMMAND, OnCheckWebCommand)
	ON_BN_CLICKED(IDC_BUTTON_SENDPROGRAM, OnButtonSendprogram)
	ON_MESSAGE(WM_MSG_DLG_WND,OnMsgPro)
	ON_BN_CLICKED(IDC_BUTTON_SELECT_FILE, OnButtonSelectFile)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON_GET_FTP_INFO, OnButtonGetFtpInfo)
	ON_BN_CLICKED(IDC_BUTTON_GET_PAGE_LOOPTIMES, OnButtonGetPageLoopTimes)
	ON_BN_CLICKED(IDC_BUTTON_GET_ANYCAST_STATUS, OnButtonGetAnycastStatus)
	ON_BN_CLICKED(IDC_BUTTON_POWER, OnButtonPower)
	ON_BN_CLICKED(IDC_BUTTON_ANYCAST, OnButtonAnycast)
	ON_BN_CLICKED(IDC_BUTTON_BRIGHTNESS, OnButtonBrightness)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSendProgramByLedDataServerDlg message handlers
CString GetAppPath()
{
	CString m_sCPath,str ;
	char dir[300] ;
	HINSTANCE hpin= AfxGetInstanceHandle() ;
	GetModuleFileName(hpin,dir,299);
	m_sCPath = dir ;//ǰ·
	str =  AfxGetApp()->m_pszExeName;
	str = str+".exe" ;
	m_sCPath.MakeLower() ;
	str.MakeLower() ;
	int ipos ;
	ipos  =  m_sCPath.Find(str ) ;
	m_sCPath.Delete(ipos ,str.GetLength()) ;  
	if ( m_sCPath.Right(1)!='\\')
	{
		m_sCPath =  m_sCPath+"\\" ;
	}
	return m_sCPath ;
}
LRESULT CSendProgramByLedDataServerDlg::OnMsgPro(WPARAM wParam, LPARAM lParam)
{
	CString strParam1="";
	strParam1.Format("wParam=%d",wParam);
	m_strFtpDownloadTip=strParam1+_T("ƿӦ:\r\n")+m_strFtpDownloadTip;
	UpdateData(FALSE);

	STRUCT_GPRS_CALLBAK_DATA_PACKET *pSt=(STRUCT_GPRS_CALLBAK_DATA_PACKET *)lParam;
	switch(wParam) 
	{
	case ENUM_COMMAND_GET_XIXUN_DTU_STATUS_OFFLINE:
		{
			SetListCardStatusColumnByXiXunDtuImei(pSt->cDtuImei,(char *)pSt->pDataBuffer,"offline");//"DTU");
			CString setefsd=pSt->cDtuImei;
		//	AfxMessageBox(setefsd+" offline");
			//AfxMessageBox("offline");
		}
		break;		
	case ENUM_COMMAND_GET_XIXUN_DTU_STATUS_ONLINE:
		{
			//STRUCT_GPRS_CALLBAK_DATA_PACKET *pSt=(STRUCT_GPRS_CALLBAK_DATA_PACKET *)lParam;
			CString setefsd=pSt->cDtuImei;
		//	AfxMessageBox(setefsd+" online");
			SetListCardStatusColumnByXiXunDtuImei(pSt->cDtuImei,(char *)pSt->pDataBuffer,"online");//"DTU");
			//::AfxBeginThread(ThreadOnInitDlgGetListCardStatus,(LPVOID)this,THREAD_PRIORITY_TIME_CRITICAL,0,0,NULL);
		}
		break;		
	case ENUM_COMMAND_FTP_DOWNLOAD_SUCCESS_BY_COM:
		{
			//m_strFtpDownloadTip=_T("FTPرϢ:\r\n")+m_strFtpDownloadTip;
			//UpdateData(FALSE);

			ProcessFtpAck(pSt);
			//AfxMessageBox("Controller get ftp command successed!");
		}
		break;
	case ENUM_COMMAND_STATISTICS_PROGRESS_BY_COM:
		{
			//STRUCT_GPRS_CALLBAK_DATA_PACKET *pSt=(STRUCT_GPRS_CALLBAK_DATA_PACKET *)lParam;
			int iPrecentValue=*((int *)&pSt->pDataBuffer[0]);
			if(iPrecentValue>=100)
				iPrecentValue=99;
			m_ctrlProgress.SetPos(iPrecentValue);
			m_ctrlProgress.Invalidate();
			//			int iSendByte=*((int *)&pSt->cValue[4]);
			//			CString strtempSendBytes="";
			//			//strtempSendBytes.Format("[%dbytes]",iSendByte);
			//			if(iSendByte>1024)
			//				strtempSendBytes="["+GetMBsizeFromKB(iSendByte/1024)+"]";
			//			else
			//					strtempSendBytes="["+FormatByteCount1(iSendByte)+"]";
//			CString strPrecentValue="";
//			strPrecentValue.Format("%3d %%",iPrecentValue);
//			AfxMessageBox(strPrecentValue);
			//			//		int iPrecentValue=*((int *)&pSt->cValue[0]);
			//			SetListCardProgressByGprsImei(pSt,iPrecentValue,strtempSendBytes+strPrecentValue,0);
		}
		break;	
	case ENUM_COMMAND_SEND_PROGRAM_FINISHED_BY_COM:
		{
			AfxMessageBox("Send program finished");
			m_ctrlProgress.SetPos(100);
			m_ctrlProgress.Invalidate();
			GetDlgItem(IDC_BUTTON_SENDPROGRAM)->EnableWindow(TRUE);
		}
		break;
	case ENUM_COMMAND_GET_SYSTEM_STATUS_ENABLE_SEND_BY_COM:
		{
			//	AfxMessageBox("ENUM_COMMAND_GET_SYSTEM_STATUS_ENABLE_SEND_BY_COM");
			SetEventEnable();
			
		}
		break;
	case ENUM_COMMAND_GET_SYSTEM_STATUS_SUCCESS_BY_COM:
		{ 
			//STRUCT_GPRS_CALLBAK_DATA_PACKET *pSt=(STRUCT_GPRS_CALLBAK_DATA_PACKET *)lParam;
			SetListCardStatus(pSt);
		}
		break;
	case ENUM_COMMAND_SEND_PROGRAM_SUCCESS_BY_COM:
		{
			//	AfxMessageBox("ENUM_COMMAND_SEND_PROGRAM_SUCCESS_BY_COM");
			SetEventEnable();
			
		}
		break;
	case ENUM_COMMAND_GET_FTP_PARAM_SUCCESSED_BY_COM:
		{
		//	STRUCT_GPRS_CALLBAK_DATA_PACKET *pSt=(STRUCT_GPRS_CALLBAK_DATA_PACKET *)lParam;
			FTP_PARAMS *pFtpStruct=(FTP_PARAMS *)(&(pSt->pDataBuffer[4]));
			if(pFtpStruct->uiSpecialFlag==0x55aa55aa)
			{
				CString strTempPort="";
				strTempPort.Format("port=%d",pFtpStruct->uiPort);
				CString strTempServerName=pFtpStruct->pServerName;
				strTempServerName="Ftp server address:"+strTempServerName;
				CString strTempUserName=pFtpStruct->pUserName;	
				strTempUserName="User name:"+strTempUserName;
				CString strTempPassword=pFtpStruct->pPassword;	
				strTempPassword="Password:"+strTempPassword;
				CString strRelativePathName=pFtpStruct->pRelativePathName;  
				strRelativePathName="Relative path:"+strRelativePathName;
				CString strInterval="";
				if(pFtpStruct->uiConnectInterval!=0)
				{
					strInterval.Format("open ftp download program onTimer,Time interval=%d minutes",pFtpStruct->uiConnectInterval);
				}

				AfxMessageBox(strTempServerName+"\r\n"+strTempPort+"\r\n"+strTempUserName+"\r\n"+strTempPassword+"\r\n"+strRelativePathName+"\r\n"+strInterval);
			}
			else
			{
				AfxMessageBox("controller no open ftp function");
			}
		}
		break;
	case ENUM_COMMAND_GET_PROGRAM_PAGE_PLAY_INFO_SUCCESSED_BY_COM:
		{
		//	STRUCT_GPRS_CALLBAK_DATA_PACKET *pSt=(STRUCT_GPRS_CALLBAK_DATA_PACKET *)lParam;
			PLAY_PROGRAM_INFO * pTempPlayLoopInfo=(PLAY_PROGRAM_INFO *)(&(pSt->pDataBuffer[4]));
			int iTempPageNumber=(pSt->iLength-sizeof(UINT))/sizeof(PLAY_PROGRAM_INFO);
			if(iTempPageNumber<=0)
			{
				AfxMessageBox("no this page ID on controller");
			}
			else
			{
				CString strTempStatus="";
				for(int i=0;i<iTempPageNumber;i++)
				{
					CString strTempPageId="";// ΨһĿIDš
					strTempPageId.Format("Page ID:%d\r\n",pTempPlayLoopInfo[i].uiFlagID);
					CString strTempLoopTimes="";// ĿҪ˵Ĵ
					strTempLoopTimes.Format("Loop Times:%d\r\n",pTempPlayLoopInfo[i].uiPlayLoopTimes);
					CString strTempTotalTime="";// ĿҪ˵ʱ䡣
					strTempTotalTime.Format("Total Times:%dseconds\r\n",pTempPlayLoopInfo[i].uiTotalTime);
					AfxMessageBox(strTempPageId+strTempLoopTimes+strTempTotalTime);
				}
			}


		
		}
		break;
	case ENUM_COMMAND_GET_ANYCAST_STATUS_SUCCESSED_BY_COM:
		{
		//	STRUCT_GPRS_CALLBAK_DATA_PACKET *pSt=(STRUCT_GPRS_CALLBAK_DATA_PACKET *)lParam;
			int iTempStatusFlag=*((int *)&pSt->pDataBuffer[4]);
			CString strTempStatus="";
			if(iTempStatusFlag==0)//
			{
				strTempStatus="Status:normal playing\r\n";
			}
			else//㲥
			{
				strTempStatus="Status:Anycast playing\r\n";

			}
			int iTempPageIndex=*((int *)&pSt->pDataBuffer[8]);
			CString strTempPageIndex="";
			strTempPageIndex.Format("page index:%d\r\n",iTempPageIndex);
			CString strTempPageName=(char *)&pSt->pDataBuffer[12];
			strTempPageName="Program name:"+strTempPageName;
			AfxMessageBox(strTempStatus+strTempPageIndex+strTempPageName);
		}
		break;
	case ENUM_COMMAND_ANYCAST_SUCCESS_BY_COM:
			AfxMessageBox("Anycast program successed");


		break;
	case ENUM_COMMAND_ADJUST_BRIGHTNESS_SUCCESS_BY_COM:
			AfxMessageBox("Adjust brightness successed");

		break;
	case ENUM_COMMAND_SWITCH_POWER_ON_SUCCESS_BY_COM:
			AfxMessageBox("power on successed");
		break;
	case ENUM_COMMAND_SWITCH_POWER_OFF_SUCCESS_BY_COM:

			AfxMessageBox("power off successed");
		break;
	default:
		break;
	}
//	if(pSt!=NULL)
//		free(pSt);
	return 0;
}

int CSendProgramByLedDataServerDlg::ProLedScreenWorkStatus(int iStatus,CString &strtempStatus)
{
	if((iStatus&(1<<ACK_VALUE_WORK_STATE_DISPLAY_ERROR))!=0)//ƿ쳣 
	{
		strtempStatus="card except";
		return ACK_VALUE_WORK_STATE_DISPLAY_ERROR;
	}
	
	if((iStatus&(1<<ACK_VALUE_WORK_STATE_WRONG_PROGRAM_UPGRADING))!=0)//״̬
	{
		strtempStatus="power off";
		if((iStatus&(1<<ACK_VALUE_WORK_STATE_WRONG_PROGRAM_UPGRADING))!=0)//״̬
		{
			strtempStatus="Updating program";//"["+g_LoadString("IDS_MESSAGE_CARD_SENDDING")+"]";
			return ACK_VALUE_WORK_STATE_WRONG_PROGRAM_UPGRADING;
		}
		if((iStatus&(1<<ACK_VALUE_WORK_STATE_WRONG_SYSTEM_UPGRADING))!=0)//״̬ϵͳ
		{
			strtempStatus="Updating firmware";//"["+g_LoadString("IDS_MESSAGE_CARD_UPGRADING")+"]";
			return ACK_VALUE_WORK_STATE_WRONG_SYSTEM_UPGRADING;
		}
		return ACK_VALUE_WORK_STATE_WRONG_PROGRAM_UPGRADING;
	}
	
	
	if((iStatus&(1<<ACK_VALUE_WORK_STATE_WRONG_PROGRAM_UPGRADING))!=0)//ͽĿ
	{
		strtempStatus+="Upgrading program";//g_LoadString("IDS_MESSAGE_CARD_SENDDING");
		return ACK_VALUE_WORK_STATE_WRONG_PROGRAM_UPGRADING;
	}
	if((iStatus&(1<<ACK_VALUE_WORK_STATE_WRONG_SYSTEM_UPGRADING))!=0)//
	{
		strtempStatus+="Updating firmware";//g_LoadString("IDS_MESSAGE_CARD_UPGRADING");
		return ACK_VALUE_WORK_STATE_WRONG_SYSTEM_UPGRADING;
	}
	if((iStatus&(1<<ACK_VALUE_WORK_STATE_WRONG_POWER_OFF))!=0)//ػ
	{
		strtempStatus+="power off";//g_LoadString("IDS_MENUITEM_CONTROL_POWER_OFF");
		return ACK_VALUE_WORK_STATE_WRONG_POWER_OFF;
		
	}
	if((iStatus&(1<<ACK_VALUE_WORK_STATE_WRONG_USB_DICK_PLAY))!=0)//U̲
	{
		strtempStatus+="playing on usb disk";//g_LoadString("IDS_MESSAGE_STATUS_USB_PLAY");
		if((iStatus&(1<<ACK_VALUE_WORK_STATE_SIZE_PRO_PANEL_NOT_SAME))!=0)
		{
			strtempStatus+=",Width Height inconsistent";//g_LoadString("IDS_MESSAGE_STATUS_SIZE_PRO_PANEL_NOT_SAME");
		}
		return ACK_VALUE_WORK_STATE_WRONG_USB_DICK_PLAY;
	}
	if((iStatus&(1<<ACK_VALUE_WORK_STATE_PALY_ERROR))!=0)//Ŀ
	{
		strtempStatus+="program except";//g_LoadString("IDS_MESSAGE_STATUS_PROGRAM_EXCEPT");
		return ACK_VALUE_WORK_STATE_PALY_ERROR;
	}
	if((iStatus&(1<<ACK_VALUE_WORK_STATE_WRONG_TESTING))!=0)
	{
		strtempStatus+="testing";//g_LoadString("IDS_MESSAGE_CARD_TESTING");
		return ACK_VALUE_WORK_STATE_WRONG_TESTING;
	}
	//
	strtempStatus+="playing";//g_LoadString("IDS_MESSAGE_CARD_PLAYING");
	if((iStatus&(1<<ACK_VALUE_WORK_STATE_SIZE_PRO_PANEL_NOT_SAME))!=0)
	{
	//	strtempStatus+=",Width Height inconsistent";//g_LoadString("IDS_MESSAGE_STATUS_SIZE_PRO_PANEL_NOT_SAME");
	}
	return ACK_VALUE_WORK_STATE_NUM;
}
CString BCD_To_STR(int iValue)
{
	CString strtemp="";
	strtemp.Format("%d",iValue);
	return strtemp;
}
CString BCD_To_HEX_STR(int iValue)
{
	CString strtemp="";
	strtemp.Format("%X",iValue);
	return strtemp;
}
void CSendProgramByLedDataServerDlg::SetListCardStatus(STRUCT_GPRS_CALLBAK_DATA_PACKET *pSt)
{
	CString FILENAME="";
	FILENAME=GetAppPath()+"status.txt";
	int n=m_ctrlLinkedCardInfo.GetItemCount();
	CString strImei=pSt->cDtuImei;
	for(int i=0;i<n;i++)
	{
		CString strtempImei=m_ctrlLinkedCardInfo.GetItemText(i,0);
		if(strcmp(strImei,strtempImei)==0)
		{
			
			STRUCT_SYSTEM_STATUS st;
			memset(&st,0x00,sizeof(STRUCT_SYSTEM_STATUS));
			memcpy(&st,pSt->pDataBuffer,sizeof(STRUCT_SYSTEM_STATUS));
			CString strTempW="";
			strTempW.Format("%d",st.iWidth);
			WritePrivateProfileString(strImei,"Width",strTempW,FILENAME);
			//			m_ctrlLinkedCardInfo.SetItemText(i,ENUM_LIST_COLUMN_WIDTH,strTempW);
			CString strTempH="";
			strTempH.Format("%d",st.iHeight);
			WritePrivateProfileString(strImei,"Height",strTempH,FILENAME);
			//			m_ctrlLinkedCardInfo.SetItemText(i,ENUM_LIST_COLUMN_HEIGHT,strTempH);
			CString strtempStatus="";
			CString strtempCurStatus="";
			ProLedScreenWorkStatus(st.iStatus,strtempCurStatus);
			WritePrivateProfileString(strImei,"Status",strtempCurStatus,FILENAME);
			m_ctrlLinkedCardInfo.SetItemText(i,2,strtempCurStatus);
			
			CString strtempDiskSize="";
			strtempDiskSize.Format("%dbytes",st.iDiskSize);
			WritePrivateProfileString(strImei,"MemorySize",strtempDiskSize,FILENAME);
			//m_ctrlLinkedCardInfo.SetItemText(i,ENUM_LIST_COLUMN_DISKSIZE,strtempDiskSize);
			
			CString strParentVersion=BCD_To_STR(st.stVersion.iMainVer);
			CString strChildVersion=BCD_To_STR(st.stVersion.iChildVer);
			//alahover090504w -s
			CString strCarSoftVersion=BCD_To_HEX_STR(st.stCardVersion.iSoftwareVer);
			CString strCarHardVersion=BCD_To_HEX_STR(st.stCardVersion.iHardwareVer);
			WritePrivateProfileString(strImei,"SV",strCarSoftVersion,FILENAME);
			WritePrivateProfileString(strImei,"HV",strCarHardVersion,FILENAME);
			
			CString strtempBrightValue="";
			strtempBrightValue.Format("%d",st.iBrightValue);
			WritePrivateProfileString(strImei,"BrightValue",strtempBrightValue,FILENAME);
			//m_ctrlLinkedCardInfo.SetItemText(i,ENUM_LIST_COLUMN_BRIGHTNESS,strtempBrightValue);
			return;
		}
	}
	
}
BOOL GetFileExist(LPCTSTR strName)
{
	DWORD dwAttr = GetFileAttributes(strName);
	if(dwAttr == 0xFFFFFFFF)   //ļв
	{
		return FALSE;
	}
	else
		return TRUE;
	
}	
BOOL CSendProgramByLedDataServerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	CallBack(ProcessCallBackMessage);
	DLL_Net_Init();
//	DLL_GPRS_Init();
	m_ctrlProgress.SetRange(0,100);
	CRect rt;
	m_ctrlLinkedCardInfo.GetClientRect(&rt);
	m_ctrlLinkedCardInfo.InsertColumn(0, "Card ID", LVCFMT_LEFT, rt.Width()/3);
	m_ctrlLinkedCardInfo.InsertColumn(1, "Name", LVCFMT_LEFT, rt.Width()/3);
	m_ctrlLinkedCardInfo.InsertColumn(2, "Status", LVCFMT_LEFT, rt.Width()/3);
	m_DlgWnd=this->m_hWnd;

	//CString strSaveDir=GetAppPath();
	//m_strProjectPathName =strSaveDir+ _T("test.xml");
	UpdateData(FALSE);
	if (m_hEnableSendNextCmd != NULL)
		ResetEvent(m_hEnableSendNextCmd);
	else
		m_hEnableSendNextCmd = CreateEvent(NULL, TRUE, FALSE, NULL);
	GetParamFromSettingTxt();
	return TRUE;  // return TRUE  unless you set the focus to a control
}
void CSendProgramByLedDataServerDlg::SaveParamToSettingTxt()
{
	UpdateData(TRUE);
	CString FILENAME="";
	FILENAME=GetAppPath()+"setting.txt";
	WritePrivateProfileString("Param","ServerAddress",m_strLedDataServerAddress,FILENAME);
	CString strPort="";
	strPort.Format("%d",m_uiPort);
	WritePrivateProfileString("Param","ServerPort",strPort,FILENAME);


	WritePrivateProfileString("Param","UserName",m_strUserName,FILENAME);
	WritePrivateProfileString("Param","Password",m_strPassword,FILENAME);
	WritePrivateProfileString("Param","ControllerID",m_strControllerID,FILENAME);
	WritePrivateProfileString("Param","ProgramName",m_strProgramName,FILENAME);
	WritePrivateProfileString("Param","ProjectPathName",m_strProjectPathName,FILENAME);
	
	CString strHeight="";
	strHeight.Format("%d",m_uiHeight);
	WritePrivateProfileString("Param","ProgramHeight",strHeight,FILENAME);
	CString strWidth="";
	strWidth.Format("%d",m_uiWidth);
	WritePrivateProfileString("Param","ProgramWidth",strWidth,FILENAME);
	CString strProgramSize="";
	strProgramSize.Format("%d",m_uiProgramSize);
	WritePrivateProfileString("Param","ProgramSize",strProgramSize,FILENAME);

	CString strMainVersion="";
	strMainVersion.Format("%d",m_uiMainVersion);
	WritePrivateProfileString("Param","Version",strMainVersion,FILENAME);
	


	if(m_ctrlCheckWeb.GetCheck())
	{
		WritePrivateProfileString("Param","WebServerChecked","1",FILENAME);
	}
	else
	{
		WritePrivateProfileString("Param","WebServerChecked","0",FILENAME);
	}
	if(m_ctrlAutoPuttingListener.GetCheck())
	{
		WritePrivateProfileString("Param","AutoPuttingListener","1",FILENAME);
	}
	else
	{
		WritePrivateProfileString("Param","AutoPuttingListener","0",FILENAME);
	}
	
	WritePrivateProfileString("Param","WebServerUrl",m_strWebServerUrl,FILENAME);
}
void CSendProgramByLedDataServerDlg::GetParamFromSettingTxt()
{
	CString FILENAME=GetAppPath()+"setting.txt";
	if(GetFileExist(FILENAME))
	{
		m_uiPort=GetPrivateProfileInt("Param","ServerPort",50000,FILENAME);
		m_uiHeight=GetPrivateProfileInt("Param","ProgramHeight",64,FILENAME);
		m_uiWidth=GetPrivateProfileInt("Param","ProgramWidth",32,FILENAME);
		int dwSize=1000;
		
		CString strtemp=_T("");
		GetPrivateProfileString("Param","ServerAddress","",strtemp.GetBuffer(dwSize),dwSize,FILENAME);
		strtemp.ReleaseBuffer();
		m_strLedDataServerAddress=strtemp;
		
		strtemp=_T("");
		GetPrivateProfileString("Param","UserName","",strtemp.GetBuffer(dwSize),dwSize,FILENAME);
		strtemp.ReleaseBuffer();
		m_strUserName=strtemp;
		
		strtemp=_T("");
		GetPrivateProfileString("Param","Password","",strtemp.GetBuffer(dwSize),dwSize,FILENAME);
		strtemp.ReleaseBuffer();
		m_strPassword=strtemp;

		strtemp=_T("");
		GetPrivateProfileString("Param","ControllerID","",strtemp.GetBuffer(dwSize),dwSize,FILENAME);
		strtemp.ReleaseBuffer();
		m_strControllerID=strtemp;


		m_uiMainVersion=GetPrivateProfileInt("Param","Version",9,FILENAME);


		strtemp=_T("");
		GetPrivateProfileString("Param","ProgramName","",strtemp.GetBuffer(dwSize),dwSize,FILENAME);
		strtemp.ReleaseBuffer();
		m_strProgramName=strtemp;

		strtemp=_T("");
		GetPrivateProfileString("Param","ProjectPathName","",strtemp.GetBuffer(dwSize),dwSize,FILENAME);
		strtemp.ReleaseBuffer();
		m_strProjectPathName=strtemp;
		
		
		m_uiProgramSize=GetPrivateProfileInt("Param","ProgramSize",0,FILENAME);
		strtemp=_T("");
		GetPrivateProfileString("Param","WebServerUrl","",strtemp.GetBuffer(dwSize),dwSize,FILENAME);
		strtemp.ReleaseBuffer();
		m_strWebServerUrl=strtemp;
		UpdateData(FALSE);
		int iChecked=GetPrivateProfileInt("Param","WebServerChecked",0,FILENAME);
		m_ctrlCheckWeb.SetCheck(iChecked);
		if(m_ctrlCheckWeb.GetCheck())
		{
			GetDlgItem(IDC_STATIC_WEB_ADDRESS)->EnableWindow(TRUE);
			GetDlgItem(IDC_EDIT_WEB_SERVER_ADD)->EnableWindow(TRUE);
		}
		else
		{
			GetDlgItem(IDC_STATIC_WEB_ADDRESS)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDIT_WEB_SERVER_ADD)->EnableWindow(FALSE);
		}
		int iAutoPuttingListenerChecked=GetPrivateProfileInt("Param","AutoPuttingListener",0,FILENAME);
		m_ctrlAutoPuttingListener.SetCheck(iAutoPuttingListenerChecked);
		if(iAutoPuttingListenerChecked==1)
		{
			GetDlgItem(IDC_BUTTON_LOGIN)->EnableWindow(FALSE);
			GetDlgItem(IDC_BUTTON_GET_USER_CONTROLLER_INFO)->EnableWindow(FALSE);
			GetDlgItem(IDC_BUTTON_DOWNLOAD)->EnableWindow(FALSE);
			
			OnButtonLogin();
		}
		else
		{
			GetDlgItem(IDC_BUTTON_LOGIN)->EnableWindow(TRUE);
			GetDlgItem(IDC_BUTTON_GET_USER_CONTROLLER_INFO)->EnableWindow(TRUE);
			GetDlgItem(IDC_BUTTON_DOWNLOAD)->EnableWindow(TRUE);
		}
		
	}
	else
	{
	}	
	UpdateData(FALSE);
}
void CSendProgramByLedDataServerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSendProgramByLedDataServerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSendProgramByLedDataServerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSendProgramByLedDataServerDlg::OnButtonLogin() 
{
	iCurGprsImeiCardNumber=0;

	UpdateData(TRUE);
	char cDnsOrIp[100]={0};
	memset(cDnsOrIp,0x00,100);
	strcpy(cDnsOrIp,m_strLedDataServerAddress);
	//if(m_iLinkServerSuccess>0)
	{
		DLL_GPRS_Close(ENUM_DTU_TYPE_XIXUN);
		Sleep(2000);
	}
	DLL_GPRS_Init();
	m_iLinkServerSuccess=DLL_GPRS_Link_Server(cDnsOrIp,m_uiPort,0,ENUM_DTU_TYPE_XIXUN,NULL);
	if(m_iLinkServerSuccess<=0)
	{
		AfxMessageBox("Link LedDataServer failed");
		GetDlgItem(IDC_BUTTON_LOGIN)->EnableWindow(TRUE);

	}
	else
	{
		char cAuth[100]={0};
		strcpy(cAuth,m_strUserName);
		char cAuthPassword[10]={0};
		strcpy(cAuthPassword,m_strPassword);
		m_iAuthResult=DLL_GPRS_Auth(cAuth,cAuthPassword,ENUM_DTU_TYPE_XIXUN);
		switch(m_iAuthResult)
		{
			case ENUM_USER_AUTH_SUCCESS:
				if(m_ctrlAutoPuttingListener.GetCheck())
				{
					OnButtonGetUserControllerInfo();
				}
				else
				{
					AfxMessageBox("login successed");
				}

			//DLL_Xixun_Get_All_Dtu_Imei_Status();
				break;
			case ENUM_USER_AUTH_SOCKET_ERROR:
				AfxMessageBox("login socket error");
				break;
			case 	ENUM_USER_NOT_LOGIN_SUCDESS:
				AfxMessageBox("login failed");
				GetDlgItem(IDC_BUTTON_LOGIN)->EnableWindow(TRUE);

				break;
			case 	ENUM_USER_NOT_EXIST:
				AfxMessageBox("user name is not exist");
				break;
			case 	ENUM_USER_PASSWORD_ERROR:
				AfxMessageBox("password error");
				break;
			case ENUM_USER_LOGIN_OTHER_PLACE:
				AfxMessageBox("user re_login");
				break;
				
		}
			
	}
	// TODO: Add your control notification handler code here
}

void CSendProgramByLedDataServerDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	DLL_GPRS_Close(ENUM_DTU_TYPE_XIXUN);
	SaveParamToSettingTxt();
	CDialog::OnClose();
}

void CSendProgramByLedDataServerDlg::OnButtonDownload() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	
	int m_uiChildVer=0x20100915;
	switch(m_iAuthResult)
	{
	case ENUM_USER_AUTH_SUCCESS:
	case ENUM_USER_LOGIN_OTHER_PLACE:
		{
			char cProgramName[500]={0};
			strcpy(cProgramName,m_strProgramName);
			char cImei[16]={0};
			strcpy(cImei,m_strControllerID);
			HANDLE iHandle=DLL_GPRS_GetClassHandle(cImei,ENUM_DTU_TYPE_XIXUN);
			//CString strHandle="";
			//strHandle.Format("Handle=%d",iHandle);
			//AfxMessageBox(strHandle);
				CString strCardType=m_strControllerID.Left(1);
				strCardType.MakeLower();
				if(strCardType=="k")
				{
					m_uiMainVersion=10;
					UpdateData(FALSE);
				}
				else if(strCardType=="m"||strCardType=="a"||strCardType=="w"||strCardType=="c")
				{
					m_uiMainVersion=9;
					UpdateData(FALSE);
				
				}
			if(m_ctrlCheckWeb.GetCheck())
			{
				char cWebServerUrl[500]={0};
				strcpy(cWebServerUrl,m_strWebServerUrl);
				char cServerAdd[100]={0};
				strcpy(cServerAdd,m_strLedDataServerAddress);

				Dll_WebServerDownloadProgramFromFtp(iHandle,cImei,cProgramName,m_uiProgramSize,m_uiMainVersion,m_uiChildVer,m_uiWidth,m_uiHeight,cServerAdd,m_uiPort,cWebServerUrl);
			}
			else
			{
				Dll_DownloadProgramFromFtp(iHandle,cImei,cProgramName,m_uiProgramSize,m_uiMainVersion,m_uiChildVer,m_uiWidth,m_uiHeight);
			//	AfxMessageBox("dd");
			}
		}
		break;
	default:
		AfxMessageBox("please Login first");
		break;
		
	}
}
int WINAPI ProcessCallBackMessage(int Param1/**/,char * Param2/*Ӧ*/)
{
	
	if(	m_DlgWnd==NULL)
		return 0;
	::SendMessage(m_DlgWnd,WM_MSG_DLG_WND,Param1,(LPARAM)Param2);
	//::PostMessage(m_DlgWnd,WM_MSG_DLG_WND,Param1,(LPARAM)Param2);

	return 0;
}	
void CSendProgramByLedDataServerDlg::SetEventEnable()
{
	SetEvent(m_hEnableSendNextCmd);
}
void CSendProgramByLedDataServerDlg::SetListCardStatusColumnByXiXunDtuImei(char *cDtuImei,char *cbuf,CString strStatus)
{
	CString strScreenId="";
	CString strCustomName="";
	char cTempCustomName[20];
	memset(cTempCustomName,0x00,20);
	strScreenId=cDtuImei;
	char cTempDtuName[16]={0};
	memset(cTempDtuName,0x00,16);
	memcpy(cTempDtuName,cbuf,16);
	strCustomName=cTempDtuName;
	int itempHaveFlag=0;
	for(int m=0;m<m_ctrlLinkedCardInfo.GetItemCount();m++)
	{
		CString strTempListCardSerial=m_ctrlLinkedCardInfo.GetItemText(m,0);
		if (strcmp(strScreenId,strTempListCardSerial)==0)
		{
			itempHaveFlag=1;
			CString strOldCustomName=m_ctrlLinkedCardInfo.GetItemText(m,1);
			if (strcmp(strOldCustomName,strCustomName)!=0)
				m_ctrlLinkedCardInfo.SetItemText(m, 1,strCustomName);
			CString strOldStatus=m_ctrlLinkedCardInfo.GetItemText(m,2);
			if (strcmp(strOldStatus,strStatus)!=0)
				m_ctrlLinkedCardInfo.SetItemText(m, 2,strStatus);
			break;
		}
	}
	if(itempHaveFlag==0)
	{
		int itempIndex=m_ctrlLinkedCardInfo.GetItemCount();
		if(itempIndex>100)
			return;
		m_ctrlLinkedCardInfo.InsertItem(itempIndex, "",0);
		m_ctrlLinkedCardInfo.SetItemText(itempIndex, 0,strScreenId);
		m_ctrlLinkedCardInfo.SetItemText(itempIndex, 1, strCustomName);
		m_ctrlLinkedCardInfo.SetItemText(itempIndex, 2, strStatus);
		HANDLE iHandle=DLL_GPRS_Get_Imei_Status(cDtuImei,ENUM_DTU_TYPE_XIXUN,0,0,0);
		DLL_GPRS_Set_Cable_Wireless_Speed_And_TimeOut_ResendTimes(iHandle,2,0,6,10,900);
		if(m_ctrlAutoPuttingListener.GetCheck())
		{
			if(strScreenId==m_strControllerID)
			{
				OnButtonDownload();
			}
		}
		//CString strHandle="";
		//strHandle.Format("oldHandle=%d",iHandle);
		//AfxMessageBox(strHandle);
	}
	return ;
	
}
void CSendProgramByLedDataServerDlg::OnButtonGetUserControllerInfo() 
{
	// TODO: Add your control notification handler code here
	switch(m_iAuthResult)
	{
		case ENUM_USER_AUTH_SUCCESS:
		case ENUM_USER_LOGIN_OTHER_PLACE:
		m_ctrlLinkedCardInfo.DeleteAllItems();
		DLL_Xixun_Get_All_Dtu_Imei_Status();
		break;
		default:
			AfxMessageBox("please Login first");
		break;
			
	}
}

void CSendProgramByLedDataServerDlg::OnClickList1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	NMLISTVIEW *pLV = (NMLISTVIEW *)pNMHDR;
	if(pLV->iItem<0)
		return;
	POSITION pos;	
	pos = m_ctrlLinkedCardInfo.GetFirstSelectedItemPosition();
	int m_IndexInFieldList = m_ctrlLinkedCardInfo.GetNextSelectedItem(pos);  // õĿ	
	if(m_IndexInFieldList<0)
		return;
	int iCardCount=m_ctrlLinkedCardInfo.GetItemCount();
	if(iCardCount<=0)
	{
		m_strControllerID="";
	}
	else if(iCardCount==1)
	{
		m_strControllerID=m_ctrlLinkedCardInfo.GetItemText(0,0);
	}
	else
	{
		m_strControllerID=m_ctrlLinkedCardInfo.GetItemText(m_IndexInFieldList,0);
		
	}	
				CString strCardType=m_strControllerID.Left(1);
				strCardType.MakeLower();
				if(strCardType=="k")
				{
					m_uiMainVersion=10;
					UpdateData(FALSE);
				}
				else if(strCardType=="m"||strCardType=="a"||strCardType=="w"||strCardType=="c")
				{
					m_uiMainVersion=9;
					UpdateData(FALSE);
				
				}
	m_strWebServerUrl = _T("GET_/wcf/WebHttpService.svc/UpdateTaskState?imei=")+m_strControllerID;//+_T("&taskId=1&stateId=6_HTTP/1.1\r\nHost:www.ledm2m.net:8088\r\n\r\n");
	*pResult = 0;
	UpdateData(FALSE);
}

void CSendProgramByLedDataServerDlg::OnCheckWebCommand() 
{
	// TODO: Add your control notification handler code here
	CString FILENAME="";
	FILENAME=GetAppPath()+"setting.txt";
	if(m_ctrlCheckWeb.GetCheck())
	{
		GetDlgItem(IDC_STATIC_WEB_ADDRESS)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_WEB_SERVER_ADD)->EnableWindow(TRUE);
		WritePrivateProfileString("Param","WebServerChecked","1",FILENAME);
	}
	else
	{
		GetDlgItem(IDC_STATIC_WEB_ADDRESS)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_WEB_SERVER_ADD)->EnableWindow(FALSE);
		WritePrivateProfileString("Param","WebServerChecked","0",FILENAME);
	}

}
UINT _Thread_GprsSendByDtuImei(LPVOID lparam)
{

	CSendProgramByLedDataServerDlg *pDlg=(CSendProgramByLedDataServerDlg*)lparam;
	pDlg->GprsSendByDtuImei();
	return 0;
}
UINT CSendProgramByLedDataServerDlg::GetCurProFileVersion()
{
	CFile fd;
	if(fd.Open(m_strProjectPathName,CFile::modeRead))//|CFile::modeWrite))
	{

		char *buf=NULL;
		int iFileLength=fd.GetLength();//MyGetFileSize(strPathName);
		if(iFileLength>=0)
		{
			buf=(char *)malloc(iFileLength);
			memset(buf,0x00,iFileLength);
			fd.Read(buf,iFileLength);
			fd.Close();
		}
		else
		{
			fd.Close();
			return 0;

		}
		if(iFileLength>10)
		{
			return (UINT)buf[8];
		}
		else
		{
			return 0;
		}
	}
	return 0;
}

void  CSendProgramByLedDataServerDlg::GprsSendByDtuImei() 
{
	UpdateData(TRUE);
	int m_uiChildVer=0x20100915;
	switch(m_iAuthResult)
	{
	case ENUM_USER_AUTH_SUCCESS:
	case ENUM_USER_LOGIN_OTHER_PLACE:
		{
			char cProgramName[500]={0};
			strcpy(cProgramName,m_strProjectPathName);
			char cImei[16]={0};
			strcpy(cImei,m_strControllerID);
			HANDLE iHandle=DLL_GPRS_GetClassHandle(cImei,ENUM_DTU_TYPE_XIXUN);
			ResetEvent(m_hEnableSendNextCmd);

			if(iHandle!=NULL)
			{
				CString strCardType=m_strControllerID.Left(1);
				strCardType.MakeLower();
				if(strCardType=="k")
				{
					m_uiMainVersion=10;
					UpdateData(FALSE);
				}
				else if(strCardType=="m"||strCardType=="a"||strCardType=="w"||strCardType=="c")
				{
					m_uiMainVersion=9;
					UpdateData(FALSE);
				
				}
				if(m_strProjectPathName.Right(3)=="lxd")
				{
					UINT iTempProgramVersion=GetCurProFileVersion();
					if(iTempProgramVersion!=m_uiMainVersion)
					{
						CString strProgramVersionTemp="";
						strProgramVersionTemp.Format("%d",iTempProgramVersion);
						CString strCardVersionTemp="";
						strCardVersionTemp.Format("%d",m_uiMainVersion);
						AfxMessageBox("program version is "+strProgramVersionTemp+",but controller version is "+strCardVersionTemp);
						GetDlgItem(IDC_BUTTON_SENDPROGRAM)->EnableWindow(TRUE);

						return;
					}
				}
				GetDlgItem(IDC_BUTTON_SENDPROGRAM)->EnableWindow(FALSE);
				DLL_GPRS_GetSystemStatus(iHandle,0,0,ENUM_CTRL_CODE1_GET_ENABLEORNOT_BEFORE_SEND,ENUM_CTRL_CODE2_GET_SYSTEM_PACKET_ENABLE_RESEND,NULL);
				if(WaitForSingleObject(m_hEnableSendNextCmd,5*10000)==WAIT_TIMEOUT)
				{
					AfxMessageBox("DLL_GPRS_GetSystemStatus time out");
					GetDlgItem(IDC_BUTTON_SENDPROGRAM)->EnableWindow(TRUE);
					return;
				}
				ResetEvent(m_hEnableSendNextCmd);

				DLL_GPRS_ReadyToSendProgram(iHandle,cProgramName,m_uiMainVersion,m_uiChildVer,0,0,0,0);
			//	AfxMessageBox(m_strControllerID);
				if(WaitForSingleObject(m_hEnableSendNextCmd,5*10000)==WAIT_TIMEOUT)
				{
					AfxMessageBox("DLL_GPRS_ReadyToSendProgram time out");
					GetDlgItem(IDC_BUTTON_SENDPROGRAM)->EnableWindow(TRUE);
					return;
				}
				ResetEvent(m_hEnableSendNextCmd);
				DLL_GPRS_SendProgramToPanel(iHandle,cProgramName,0x00,0x00,0,0);
				//AfxMessageBox(cProgramName);
				/*if(DLL_GPRS_SendProgramToPanel(iHandle,cProgramName,0x00,0x00,0,0)==0)
					AfxMessageBox("DLL_GPRS_SendProgramToPanel return 0");
				else
					AfxMessageBox("DLL_GPRS_SendProgramToPanel return -1");*/
			}
		}
		
		break;
	default:
		AfxMessageBox("please Login first");
		break;
		
	}
}
void CSendProgramByLedDataServerDlg::OnButtonSendprogram() 
{
	// TODO: Add your control notification handler code here
	char cContab[20]={0};
	strcpy(cContab,"contab.txt");
	char cProgramNameDir[500]={0};
	strcpy(cProgramNameDir,m_strProjectPathName.Left(m_strProjectPathName.GetLength()-4));
	DLL_Set_Contab_File_version(1);
	DLL_Make_Contab_File(cProgramNameDir,cContab);
	m_ctrlProgress.SetPos(0);
	::AfxBeginThread(_Thread_GprsSendByDtuImei,this,THREAD_PRIORITY_TIME_CRITICAL,0,0,NULL);

}

void CSendProgramByLedDataServerDlg::OnButtonSelectFile() 
{
	// TODO: Add your control notification handler code here
	CFileDialog dlg(TRUE, NULL, 
		NULL, OFN_HIDEREADONLY, "\r\nPIC FILE(*.xml *.lxd) |*.xml;*.lxd|",
		this);
	dlg.m_ofn.Flags |= OFN_NOCHANGEDIR;	
	if (IDOK == dlg.DoModal())
	{
		m_strProjectPathName=dlg.GetPathName();
		UpdateData(FALSE);
	}
		
}

void CSendProgramByLedDataServerDlg::OnOK() 
{
	// TODO: Add extra validation here
	DLL_GPRS_Close(ENUM_DTU_TYPE_XIXUN);
	SaveParamToSettingTxt();
	
	CDialog::OnOK();
}

void CSendProgramByLedDataServerDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
//	DLL_GPRS_Close(ENUM_DTU_TYPE_XIXUN);
//	DLL_GPRS_Init();
	GetParamFromSettingTxt();
	//	OnButtonLogin();
	

	
}

void CSendProgramByLedDataServerDlg::OnCheck1() 
{
	// TODO: Add your control notification handler code here
	CString FILENAME="";
	FILENAME=GetAppPath()+"setting.txt";
	if(m_ctrlAutoPuttingListener.GetCheck())
	{
		GetDlgItem(IDC_BUTTON_LOGIN)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_GET_USER_CONTROLLER_INFO)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_DOWNLOAD)->EnableWindow(FALSE);
		WritePrivateProfileString("Param","AutoPuttingListener","1",FILENAME);
//		DLL_GPRS_Close(ENUM_DTU_TYPE_XIXUN);
//		DLL_GPRS_Init();
		GetParamFromSettingTxt();
	}
	else
	{
		GetDlgItem(IDC_BUTTON_LOGIN)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON_GET_USER_CONTROLLER_INFO)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON_DOWNLOAD)->EnableWindow(TRUE);
		WritePrivateProfileString("Param","AutoPuttingListener","0",FILENAME);
	}
	
}


void CSendProgramByLedDataServerDlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
	SaveParamToSettingTxt();
}
void CSendProgramByLedDataServerDlg::OnButtonGetPageLoopTimes()
{
	UpdateData(TRUE);
	int itempIndex=m_ctrlLinkedCardInfo.GetItemCount();
	if(itempIndex>100)
		return;
	switch(m_iAuthResult)
	{
	case ENUM_USER_AUTH_SUCCESS:
	case ENUM_USER_LOGIN_OTHER_PLACE:
		{
			char cImei[16]={0};
			strcpy(cImei,m_strControllerID);
			HANDLE iHandle=DLL_GPRS_GetClassHandle(cImei,ENUM_DTU_TYPE_XIXUN);
			DLL_GPRS_Get_ProgramPage_PlayInfo(iHandle,m_uiPageId,0x00,0x00,0x00,0x00);

		}
		break;
	default:
		AfxMessageBox("please Login first");
		break;
	}

}
void CSendProgramByLedDataServerDlg::OnButtonGetFtpInfo()
{
	int itempIndex=m_ctrlLinkedCardInfo.GetItemCount();
	if(itempIndex>100)
		return;
	switch(m_iAuthResult)
	{
	case ENUM_USER_AUTH_SUCCESS:
	case ENUM_USER_LOGIN_OTHER_PLACE:
		{
			char cImei[16]={0};
			strcpy(cImei,m_strControllerID);
			HANDLE iHandle=DLL_GPRS_GetClassHandle(cImei,ENUM_DTU_TYPE_XIXUN);
			DLL_GPRS_Get_FtpParam(iHandle,0x00,0x00,0x00,0x00);
		}
		break;
	default:
		AfxMessageBox("please Login first");
		break;
	}
}
void CSendProgramByLedDataServerDlg::OnButton3() 
{
	int itempIndex=m_ctrlLinkedCardInfo.GetItemCount();
	if(itempIndex>100)
		return;
	for(int i=0;i<itempIndex;i++)
	{
		CString strTempControllerID=m_ctrlLinkedCardInfo.GetItemText(i,0);
		char cImei[16]={0};
		strcpy(cImei,strTempControllerID);
		HANDLE iHandle=DLL_GPRS_GetClassHandle(cImei,ENUM_DTU_TYPE_XIXUN);
		CString strTempStatus=m_ctrlLinkedCardInfo.GetItemText(i,2);
		if(strTempStatus=="offline")
		{
			CString FILENAME="";
			FILENAME=GetAppPath()+"status.txt";
			WritePrivateProfileString(strTempControllerID,"Status",strTempStatus,FILENAME);
		}
		DLL_GPRS_GetSystemStatus(iHandle,0x00,0x00,0x00,0x00,NULL);
	}
	
	// TODO: Add your control notification handler code here
	
}

void CSendProgramByLedDataServerDlg::OnButtonGetAnycastStatus() 
{

	// TODO: Add your control notification handler code here
	int itempIndex=m_ctrlLinkedCardInfo.GetItemCount();
	if(itempIndex>100)
		return;
	switch(m_iAuthResult)
	{
	case ENUM_USER_AUTH_SUCCESS:
	case ENUM_USER_LOGIN_OTHER_PLACE:
		{
			char cImei[16]={0};
			strcpy(cImei,m_strControllerID);
			HANDLE iHandle=DLL_GPRS_GetClassHandle(cImei,ENUM_DTU_TYPE_XIXUN);
			DLL_GPRS_Get_Anycast_Status(iHandle,0x00,0x00,0x00,0x00);
		}
		break;
	default:
		AfxMessageBox("please Login first");
		break;
	}	
}

void CSendProgramByLedDataServerDlg::OnButtonPower() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	int itempIndex=m_ctrlLinkedCardInfo.GetItemCount();
	if(itempIndex>100)
		return;
	switch(m_iAuthResult)
	{
	case ENUM_USER_AUTH_SUCCESS:
	case ENUM_USER_LOGIN_OTHER_PLACE:
		{
			char cImei[16]={0};
			strcpy(cImei,m_strControllerID);
			HANDLE iHandle=DLL_GPRS_GetClassHandle(cImei,ENUM_DTU_TYPE_XIXUN);
			DLL_GPRS_SwitchPanel(iHandle,m_iRadioPower,0x00,0x00,0x00,0x00);
		}
		break;
	default:
		AfxMessageBox("please Login first");
		break;
	}
	
}

void CSendProgramByLedDataServerDlg::OnButtonAnycast() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	int itempIndex=m_ctrlLinkedCardInfo.GetItemCount();
	if(itempIndex>100)
		return;
	switch(m_iAuthResult)
	{
	case ENUM_USER_AUTH_SUCCESS:
	case ENUM_USER_LOGIN_OTHER_PLACE:
		{
			char cImei[16]={0};
			strcpy(cImei,m_strControllerID);
			HANDLE iHandle=DLL_GPRS_GetClassHandle(cImei,ENUM_DTU_TYPE_XIXUN);
			DLL_GPRS_Anycast(iHandle,m_uiPageIndex,0x00,0x00,0x00,0x00);
		}
		break;
	default:
		AfxMessageBox("please Login first");
		break;
	}
	
}

void CSendProgramByLedDataServerDlg::OnButtonBrightness() 
{
	UpdateData(TRUE);
	int itempIndex=m_ctrlLinkedCardInfo.GetItemCount();
	if(itempIndex>100)
		return;
	switch(m_iAuthResult)
	{
	case ENUM_USER_AUTH_SUCCESS:
	case ENUM_USER_LOGIN_OTHER_PLACE:
		{
			char cImei[16]={0};
			strcpy(cImei,m_strControllerID);
			HANDLE iHandle=DLL_GPRS_GetClassHandle(cImei,ENUM_DTU_TYPE_XIXUN);
			DLL_GPRS_AdjustBrightness(iHandle,m_uiBrightNess,0x00,0x00,0x00,0x00);
		}
		break;
	default:
		AfxMessageBox("please Login first");
		break;
	}
	// TODO: Add your control notification handler code here
	
}

void CSendProgramByLedDataServerDlg::ProcessFtpAck(STRUCT_GPRS_CALLBAK_DATA_PACKET *pSt)
{
			FTP_ACK_PARAMS stFtpAckParam;
			memset(&stFtpAckParam,0x00,sizeof(stFtpAckParam));
			memcpy(&stFtpAckParam,pSt->pDataBuffer,sizeof(stFtpAckParam));
			switch(stFtpAckParam.uiFtpGet_Stage)
			{
			case FTP_GET_STAGE_NONE:
				{
					CString strTempImei=pSt->cDtuImei;
					m_strFtpDownloadTip=strTempImei+_T("֪ͨFTP\r\n")+m_strFtpDownloadTip;
					UpdateData(FALSE);

				}
				break;
			case FTP_GET_STAGE_LOGIN:
				{
					CString strTempImei=pSt->cDtuImei;
					m_strFtpDownloadTip=strTempImei+_T("FTP½ɹ\r\n")+m_strFtpDownloadTip;
						UpdateData(FALSE);
				}
				break;
			case FTP_GET_STAGE_GETTING_FILE:
				{
						CString strTempImei=pSt->cDtuImei;
						stFtpAckParam.uiFtpGet_StageType;
						if(stFtpAckParam.uiFtpGet_StageType>=99)
						{
							m_strFtpDownloadTip=strTempImei+_T("")+_T("\r\n")+m_strFtpDownloadTip;
							UpdateData(FALSE);
						}
						else
						{
							CString strPrecent=_T("");
							strPrecent.Format(_T("%d%%"),stFtpAckParam.uiFtpGet_StageType);
							m_strFtpDownloadTip=strTempImei+_T("ؽ")+strPrecent+_T("\r\n")+m_strFtpDownloadTip;
							UpdateData(FALSE);
						}

				}
				break;
			case FTP_GET_STAGE_FAILE:
				{
					m_strFtpDownloadTip=_T("FTPȡļʧ\r\n")+m_strFtpDownloadTip;
					UpdateData(FALSE);
				}
				break;
			}
	
}
