using System;
using System.Collections.Generic;
//using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
namespace CSharpSendProgramInLan
{
    unsafe class InterfaceDll
   {
        public InterfaceDll(IntPtr handle, string strAppPath)
        { 
            sIntHandle=handle;
            m_CurAppStartPath = strAppPath;
            m_staticCurAppStartPath = m_CurAppStartPath;
        }
        static IntPtr sIntHandle;
        static int m_staticCurLanguage = 0;
        static string m_staticCurAppStartPath = "";
        private int m_CurLanguage = 0;
        public string m_CurAppStartPath = "";

       #region member variable define
     //  [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi)] //,Size=16          
       [System.Runtime.InteropServices.StructLayout(LayoutKind.Explicit)]
       public struct CallbackStruct
       {
           [System.Runtime.InteropServices.FieldOffset(0)]
           [MarshalAs(UnmanagedType.ByValArray, SizeConst = 20)] //, FieldOffset(10)]
           public byte[] ip;
           [System.Runtime.InteropServices.FieldOffset(20)]
           public UInt32 iPort;
           [System.Runtime.InteropServices.FieldOffset(24)]
           [MarshalAs(UnmanagedType.ByValArray, SizeConst = 2000)] //, FieldOffset(10)]
           public byte[] buffer;
       }
       #endregion
       #region delegate callback function
       //ص ̬ⷵصϢ
     //  public delegate void CALLBACK_PROC(int iType, StringBuilder buffer);
       public delegate void CALLBACK_PROC(int iType, char * buffer);
       CALLBACK_PROC myCallbackFunc = new CALLBACK_PROC(ProcessCallBackMessage);
       #endregion


        #region DLL Declaration
        //ʼ
        [DllImport("Interface.dll", EntryPoint = "DLL_Net_Init", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Winapi)]
        private static extern void DLL_Net_Init();
        //ȡ⵽Ļ
        [DllImport("Interface.dll", EntryPoint = "DLL_Net_GetCardNumberInLan", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Winapi)]
        private static extern int DLL_Net_GetCardNumberInLan(String cLocalIp);

        [DllImport("Interface.dll", EntryPoint = "DLL_Net_ClearCardInLan", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Winapi)]
        private static extern int DLL_Net_ClearCardInLan();
        
        //ȡ⵽ĴĻIP
        [DllImport("Interface.dll", EntryPoint = "DLL_Net_GetCardIpFromList", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Winapi)]
        private static extern void DLL_Net_GetCardIpFromList(int index, StringBuilder ip, StringBuilder id);
       //ĻIP
        [DllImport("Interface.dll", EntryPoint = "DLL_Net_SetScreenOnlyIp", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Winapi)]
        private static extern void DLL_Net_SetScreenOnlyIp(string ip/*IPַ*/, int iPort, string screenIp);

        //ָIP
        [DllImport("Interface.dll", EntryPoint = "DLL_Net_RestoreScreenIp", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Winapi)]
        private static extern void DLL_Net_RestoreScreenIp(string ip/*IPַ*/,int iPort,string newIp,string cLocalIp);

        [DllImport("Interface.dll", EntryPoint = "DLL_Net_Anycast", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Winapi)]
        private static extern void DLL_Net_Anycast(String ip/*IPַ*/, int iPort, int iProgramIndex, IntPtr socket);
       
        //ڴĻ
        [DllImport("Interface.dll", EntryPoint = "DLL_Net_AdjustBrightness", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Winapi)]
        private static extern void DLL_Net_AdjustBrightness(String ip/*IPַ*/, int iPort, int iBrightnessValue/*ֵ(0 ~ 8)*/, IntPtr socket);
        //شĻ
        [DllImport("Interface.dll", EntryPoint = "DLL_Net_SwitchPanel", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Winapi)]
        private static extern void DLL_Net_SwitchPanel(String ip/*IPַ*/, int iPort, int iOnOffFlag/*0:,1:*/, IntPtr socket);
         //ȡĻϵͳ״̬
        [DllImport("Interface.dll", EntryPoint = "DLL_Net_GetSystemStatus", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Winapi)]
        private static extern int DLL_Net_GetSystemStatus(String ip/*IPַ*/, int iPort, byte ucCtrl2, IntPtr mySocket);

        //ͽĿ׼ѯ汾Ƿƥ䣬Ƿ
        [DllImport("Interface.dll", EntryPoint = "DLL_Net_ReadyToSendProgram", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Winapi)]
        private static extern int DLL_Net_ReadyToSendProgram(String ip/*IPַ*/, int iPort, String cPanthName/*ĿĿ¼*/, int iMainVer/*汾*/, int iChildVer/*ڰ汾 */, IntPtr mySocket);
        //ͽĿ
        [DllImport("Interface.dll", EntryPoint = "DLL_Net_SendProgramToPanel", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Winapi)]
        private static extern void DLL_Net_SendProgramToPanel(String ip/*IPַ*/, int iPort, String cPanthName/*ĿĿ¼*/, IntPtr mySocket);
        [DllImport("Interface.dll", EntryPoint = "DLL_Make_Contab_File", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Winapi)]
        private static extern int DLL_Make_Contab_File(String cPanthName, String cFileName);
        [DllImport("Interface.dll", EntryPoint = "DLL_Net_SendFontToPanel", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Winapi)]
        private static extern void DLL_Net_SendFontToPanel(String ip, int iPort, String cPanthName, IntPtr mySocket);
         [DllImport("Interface.dll", EntryPoint = "DLL_Net_UpgradeCardSoftware", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Winapi)]
        private static extern void DLL_Net_UpgradeCardSoftware(String ip, int iPort, String cPanthName);
      
        
        //У׼Ļʱ
        [DllImport("Interface.dll", EntryPoint = "DLL_Net_AdjustClock", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Winapi)]
        private static extern void DLL_Net_AdjustClock(String ip/*IPַ*/, int iPort, IntPtr mySocket);
       
        [DllImport("Interface.dll", EntryPoint = "CallBack", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        private static extern void CallBack([In] CALLBACK_PROC rf); 

        [DllImport("Interface.dll", EntryPoint = "DLL_Make_Contab_File", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        private static extern int DLL_Make_Contab_File(string strProjectPathName);

         [DllImport("Interface.dll", EntryPoint = "DLL_Net_SendRegularInstructionList", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        private static extern void DLL_Net_SendRegularInstructionList(String ip/*IPַ*/, int iPort, string strPathName,IntPtr mySocket);

         [DllImport("Interface.dll", EntryPoint = "DLL_Net_GetRegularInstructionList", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
         private static extern void DLL_Net_GetRegularInstructionList(String ip/*IPַ*/, int iPort, string strPathName, IntPtr mySocket);

         [DllImport("Interface.dll", EntryPoint = "GetUsbDiskNumber", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
         private static extern int GetUsbDiskNumber();

         [DllImport("Interface.dll", EntryPoint = "GetUsbDiskNameByIndex", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
         private static extern void GetUsbDiskNameByIndex(int index, StringBuilder strUsbName);

         [DllImport("Interface.dll", EntryPoint = "GetUsbDiskFreeSpace", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
         private static extern ulong GetUsbDiskFreeSpace(String strDiskName);
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
         [DllImport("Interface.dll", EntryPoint = "DLL_GPRS_Link_Server", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
         private static extern int DLL_GPRS_Link_Server(string dc_host, ushort dc_port, int block, int iDtuType, string cLocalIp);

         [DllImport("Interface.dll", EntryPoint = "DLL_GPRS_Auth", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
         private static extern int DLL_GPRS_Auth(string cUserName, string cPassword, int iDtuType);
 
         [DllImport("Interface.dll", EntryPoint = "DLL_Xixun_Get_All_Dtu_Imei_Status", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
         private static extern int DLL_Xixun_Get_All_Dtu_Imei_Status();

         [DllImport("Interface.dll", EntryPoint = "DLL_GPRS_GetClassHandle", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
         private static extern IntPtr DLL_GPRS_GetClassHandle(string strImei, int iDtuType);

         [DllImport("Interface.dll", EntryPoint = "DLL_GPRS_GetSystemStatus", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
         private static extern int DLL_GPRS_GetSystemStatus(IntPtr iHandle,byte ucDest,byte ucSrc,byte ucCtrl1,byte ucCtrl2,string pPassword);

         [DllImport("Interface.dll", EntryPoint = "DLL_GPRS_ReadyToSendProgram", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
         private static extern int DLL_GPRS_ReadyToSendProgram(IntPtr iHandle, string cProgramName, UInt32 m_uiMainVer, UInt32 m_uiChildVer, byte dest, byte src, byte ctrl1, byte ctrl2);

         [DllImport("Interface.dll", EntryPoint = "DLL_GPRS_SendProgramToPanel", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
         private static extern int DLL_GPRS_SendProgramToPanel(IntPtr iHandle, string cProgramName,  byte dest, byte src, byte ctrl1, byte ctrl2);

          [DllImport("Interface.dll", EntryPoint = "DLL_GPRS_Get_Imei_Status", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
         private static extern int DLL_GPRS_Get_Imei_Status(string cModImei,int iDtuType,int iCheckInType,int iUdpHoleFlag,int iUdpTcpType);
     
        #endregion

        #region SendMessage to wnd function declaration
        //صзϢFORM1
        [DllImport("User32.dll", CharSet = CharSet.Auto)]
     //   private static extern int SendMessage(int hWnd, int Msg, int wParam, string lParam);
        private static extern int SendMessage(int hWnd, int Msg, int wParam, IntPtr lParam);
       
        //private static extern int SendMessage(int hWnd, int Msg, int wParam, char * lParam);
        [DllImport("User32.dll")]
        private static extern int FindWindow(string strClassName, string strWindowName);
        [DllImport("User32.dll")]
        private static extern int FindWindowEx(int hwndParent, int hwndChildAfter, string strClassName, string strWindowName);
        [DllImport("User32.dll ")]
        private static extern IntPtr PostMessage(int hwnd, int wMsg, int wParam, string lParam);
        #endregion
        #region read and write memory function
        [DllImport("kernel32.dll")]
public static extern
IntPtr OpenProcess(UInt32 dwDesiredAccess, Int32 bInheritHandle, UInt32 dwProcessId);
[DllImport("kernel32.dll")]
public static extern
Int32 WriteProcessMemory(IntPtr hProcess, IntPtr lpBaseAddress, uint[] lpBuffer, UInt32 nSize, IntPtr lpNumberOfBytesWritten);
[DllImport("kernel32.dll")]
public static extern
Int32 ReadProcessMemory(IntPtr hProcess, IntPtr lpBaseAddress, byte[] lpBuffer, UInt32 nSize, IntPtr lpNumberOfBytesRead);
       // [DllImportAttribute("kernel32.dll", EntryPoint = "ReadProcessMemory")]
       // public static extern bool ReadProcessMemory(IntPtr hProcess,IntPtr lpBaseAddress,IntPtr lpBuffer,int nSize,IntPtr lpNumberOfBytesRead);
        //[DllImportAttribute("kernel32.dll", EntryPoint = "OpenProcess")]
        //public static extern IntPtr OpenProcess(int dwDesiredAccess,bool bInheritHandle,int dwProcessId);
        #endregion

        #region callback function
       
    //    public static void ProcessCallBackMessage(int iType, StringBuilder buffer)
       public static void ProcessCallBackMessage(int iType, char * buffer)
        {
            //string strIp = Marshal.PtrToStringAnsi((IntPtr)buffer, 2000);
            int h1 =(int) sIntHandle;//0;
            
            h1 = FindWindow(null, "CSharpSendProgramInLan");
            if (h1 != 0)
                SendMessage(h1, 2000, iType, (IntPtr)buffer);
        }
        #endregion

       #region member function
       public void InitCallBackFunc()
        {
            CallBack(myCallbackFunc);
        }

        public void Call_DLL_Net_Init()
        {
            DLL_Net_Init();
        }
        public int Call_DLL_Net_GetCardNumberInLan(String cLocalIp)
        { 
            return DLL_Net_GetCardNumberInLan( cLocalIp);
        }
        public int Call_DLL_Net_ClearCardInLan()
        {
            return DLL_Net_ClearCardInLan();
        }
        public void Call_DLL_Net_GetCardIpFromList(int index, StringBuilder ip, StringBuilder id)
        {
            DLL_Net_GetCardIpFromList( index,  ip,  id);
        }
        public void Call_DLL_Net_Anycast(String ip/*IPַ*/, int iPort, int iProgramIndex, IntPtr socket)
        {
            DLL_Net_Anycast(ip, iPort, iProgramIndex, socket);
        }
        public void Call_DLL_Net_AdjustBrightness(String ip/*IPַ*/, int iPort, int iBrightnessValue/*ֵ(0 ~ 8)*/, IntPtr socket)
        {
             DLL_Net_AdjustBrightness(ip,iPort,iBrightnessValue,socket);
        }
        public void Call_DLL_Net_SwitchPanel(String ip/*IPַ*/, int iPort, int iOnOffFlag/*0:,1:*/, IntPtr socket)
        {
            DLL_Net_SwitchPanel(ip, iPort, iOnOffFlag, socket);
        }
        public int Call_DLL_Net_GetSystemStatus(String ip/*IPַ*/, int iPort, byte ucCtrl2, IntPtr mySocket)
        { 
           return DLL_Net_GetSystemStatus( ip/*IPַ*/,  iPort,  ucCtrl2,  mySocket);
        }
       public int Call_DLL_Net_ReadyToSendProgram(String ip/*IPַ*/, int iPort, String cPanthName/*ĿĿ¼*/, int iMainVer/*汾*/, int iChildVer/*ڰ汾 */, IntPtr mySocket)
        {
            return DLL_Net_ReadyToSendProgram(ip/*IPַ*/, iPort, cPanthName/*ĿĿ¼*/, iMainVer/*汾*/, iChildVer/*ڰ汾 */, mySocket);
        }
        //ͽĿ
        public void Call_DLL_Net_SendProgramToPanel(String ip/*IPַ*/, int iPort, String cPanthName/*ĿĿ¼*/, IntPtr mySocket)
        { 
            DLL_Net_SendProgramToPanel( ip/*IPַ*/,  iPort,  cPanthName/*ĿĿ¼*/,  mySocket);
        }
        //Э̱
        public void Call_DLL_Make_Contab_File(String cPanthName, String cFileName)
        {
            DLL_Make_Contab_File(cPanthName, cFileName);
        }
        //̼ͬ
        public void Call_DLL_Net_UpgradeCardSoftware(String ip/*IPַ*/, int iPort, String cPanthName/*ĿĿ¼*/, IntPtr mySocket)
        {
            DLL_Net_UpgradeCardSoftware(ip, iPort, cPanthName);
        }
        
        public void Call_DLL_Net_AdjustClock(String ip/*IPַ*/, int iPort, IntPtr mySocket)
        { 
            DLL_Net_AdjustClock( ip/*IPַ*/,  iPort,  mySocket);
        }
        public void Call_DLL_Net_SendRegularInstructionList(String ip/*IPַ*/, int iPort, string strPathName, IntPtr mySocket)
        { 
            DLL_Net_SendRegularInstructionList( ip/*IPַ*/,  iPort,  strPathName,  mySocket);
        }
        public void Call_DLL_Net_GetRegularInstructionList(String ip/*IPַ*/, int iPort, string strPathName, IntPtr mySocket)
        {
            DLL_Net_GetRegularInstructionList(ip/*IPַ*/, iPort, strPathName, mySocket);
        }
        ////////////ָIP
        public void Call_DLL_Net_RestoreScreenIp(string ip/*IPַ*/,int iPort,string newIp,string cLocalIp)
        {
           DLL_Net_RestoreScreenIp(ip/*IPַ*/,iPort,newIp, cLocalIp);
        }
        ///////////õIP
        public void Call_DLL_Net_SetScreenOnlyIp(string ip/*IPַ*/, int iPort, string screenIp/*IP*/)
        {           
            DLL_Net_SetScreenOnlyIp( ip/*IPַ*/,  iPort,  screenIp);
        }

        public int Call_Dll_GetUsbDiskNumber()
       {
           return GetUsbDiskNumber();
        }
        public void Call_Dll_GetUsbDiskName(int index,StringBuilder strUsbName)
        {
           GetUsbDiskNameByIndex(index,strUsbName);
        }

       public ulong Call_Dll_GetUsbDiskFreeSpace(string strUsbName)
        {
            return (ulong)GetUsbDiskFreeSpace(strUsbName);
        }
       public int Call_DLL_GPRS_Link_Server(string dc_host, ushort dc_port, int block, int iDtuType, string cLocalIp)
       {
           return DLL_GPRS_Link_Server( dc_host,  dc_port,  block,  iDtuType,  cLocalIp);
       }
       public int Call_DLL_GPRS_Auth(string cUserName, string cPassword, int iDtuType)
       {
           return DLL_GPRS_Auth( cUserName,  cPassword,  iDtuType);
       }
       public int Call_DLL_Xixun_Get_All_Dtu_Imei_Status()
       {
           return DLL_Xixun_Get_All_Dtu_Imei_Status();
       }
       public IntPtr Call_DLL_GPRS_GetClassHandle(string strImei, int iDtuType)
       {
           return DLL_GPRS_GetClassHandle( strImei, iDtuType);
       }
       public int Call_DLL_GPRS_GetSystemStatus(IntPtr iHandle, byte ucDest, byte ucSrc, byte ucCtrl1, byte ucCtrl2, string pPassword)
       {
           return DLL_GPRS_GetSystemStatus(iHandle,ucDest,ucSrc,ucCtrl1, ucCtrl2, pPassword);
       }
       public int Call_DLL_GPRS_ReadyToSendProgram(IntPtr iHandle, string cProgramName, UInt32 m_uiMainVer, UInt32 m_uiChildVer)
       {
           return DLL_GPRS_ReadyToSendProgram(iHandle,cProgramName,m_uiMainVer,m_uiChildVer,0,0,0,0);
       } 
        public int Call_DLL_GPRS_SendProgramToPanel(IntPtr iHandle, string cProgramName)
       {
           return DLL_GPRS_SendProgramToPanel(iHandle,cProgramName,0,0,0,0);
       }
        public int Call_DLL_GPRS_Get_Imei_Status(string cModImei,int iDtuType, int iCheckInType, int iUdpHoleFlag, int iUdpTcpType)
       {
           return DLL_GPRS_Get_Imei_Status( cModImei, iDtuType,  iCheckInType,  iUdpHoleFlag,  iUdpTcpType);
       }       

         
        #endregion
    }
}

