﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
//using XiXunLedInterface;
namespace xixunDemo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        private XiXunLedProgram m_led;
        private OpenFileDialog openFileDialog1;
        private void Form1_Load(object sender, EventArgs e)
        {
            m_led = new XiXunLedProgram();
            m_led.Call_CI_InitDLL();
       }


        private void button3_Click(object sender, EventArgs e)
        {
            string strPath = textBoxProjectPath.Text;
            if (strPath == "")
                return;

            string strSave = System.IO.Path.GetDirectoryName(strPath);
            MessageBox.Show(strPath+(",")+strSave);


            m_led.Call_CI_CompileProgram(strPath, strSave);
        }

       void button4_Click(object sender, EventArgs e)
        {

            this.openFileDialog1 = new OpenFileDialog();
            //           this.openFileDialog1.InitialDirectory = "c:\\";
            this.openFileDialog1.Filter = "project files (*.xml)|*.xml";
            this.openFileDialog1.FilterIndex = 1;
            this.openFileDialog1.RestoreDirectory = false;
            this.openFileDialog1.Multiselect = false;
            this.openFileDialog1.Title = "Select project file";

            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                string strFileName = this.openFileDialog1.FileName;
                textBoxProjectPath.Text = strFileName;
            }
        }

       private void Form1_FormClosed(object sender, FormClosedEventArgs e)
       {
           m_led.Call_CI_UnInitDLL();
       }
    }
}
